/*******************************************************************************
  Snes9x - Portable Super Nintendo Entertainment System (TM) emulator.
 
  (c) Copyright 1996 - 2003 Gary Henderson (gary.henderson@ntlworld.com) and
                            Jerremy Koot (jkoot@snes9x.com)

  (c) Copyright 2002 - 2003 Matthew Kendora and
                            Brad Jorsch (anomie@users.sourceforge.net)
 

                      
  C4 x86 assembler and some C emulation code
  (c) Copyright 2000 - 2003 zsKnight (zsknight@zsnes.com),
                            _Demo_ (_demo_@zsnes.com), and
                            Nach (n-a-c-h@users.sourceforge.net)
                                          
  C4 C++ code
  (c) Copyright 2003 Brad Jorsch

  DSP-1 emulator code
  (c) Copyright 1998 - 2003 Ivar (ivar@snes9x.com), _Demo_, Gary Henderson,
                            John Weidman (jweidman@slip.net),
                            neviksti (neviksti@hotmail.com), and
                            Kris Bleakley (stinkfish@bigpond.com)
 
  DSP-2 emulator code
  (c) Copyright 2003 Kris Bleakley, John Weidman, neviksti, Matthew Kendora, and
                     Lord Nightmare (lord_nightmare@users.sourceforge.net

  OBC1 emulator code
  (c) Copyright 2001 - 2003 zsKnight, pagefault (pagefault@zsnes.com)
  Ported from x86 assembler to C by sanmaiwashi

  SPC7110 and RTC C++ emulator code
  (c) Copyright 2002 Matthew Kendora with research by
                     zsKnight, John Weidman, and Dark Force

  S-RTC C emulator code
  (c) Copyright 2001 John Weidman
  
  Super FX x86 assembler emulator code 
  (c) Copyright 1998 - 2003 zsKnight, _Demo_, and pagefault 

  Super FX C emulator code 
  (c) Copyright 1997 - 1999 Ivar and Gary Henderson.



 
  Specific ports contains the works of other authors. See headers in
  individual files.
 
  Snes9x homepage: http://www.snes9x.com
 
  Permission to use, copy, modify and distribute Snes9x in both binary and
  source form, for non-commercial purposes, is hereby granted without fee,
  providing that this license information and copyright notice appear with
  all copies and any derived work.
 
  This software is provided 'as-is', without any express or implied
  warranty. In no event shall the authors be held liable for any damages
  arising from the use of this software.
 
  Snes9x is freeware for PERSONAL USE only. Commercial users should
  seek permission of the copyright holders first. Commercial use includes
  charging money for Snes9x or software derived from Snes9x.
 
  The copyright holders request that bug fixes and improvements to the code
  should be forwarded to them so everyone can benefit from the modifications
  in future versions.
 
  Super NES and Super Nintendo Entertainment System are trademarks of
  Nintendo Co., Limited and its subsidiary companies.
*******************************************************************************/

/*******************************************************************************
  Snes9x custom (Snes9x for Mac OS X) by zones
  
  This build was started from John Stiles' port.
*******************************************************************************/

#include "mac-prefix.h"

#include <Carbon/Carbon.h>
#include "font.h"
#include "memmap.h"
#include "cheats.h"
#include "mac-dialog.h"
#include "mac-os.h"
#include "mac-stringtools.h"
#include "mac-cheatfinder.h"

#define	MAIN_MEMORY_SIZE		0x20000

#define	kCFNumBytesPop			'Size'
#define	kCFViewModeRad			'Mode'
#define	kCFCompModePop			'Math'
#define kCFCompStoredRad		'RSto'
#define	kCFCompLastRad			'RLst'
#define	kCFCompThisRad			'RThs'
#define	kCFCompValueTxt			'CTxt'
#define	kCFSearchBtn			'BSea'
#define	kCFStoreValueBtn		'BSto'
#define	kCFWatchBtn				'BWat'
#define	kCFWatchAddrTxt			'WTxt'
#define	kCFRestoreBtn			'BRes'
#define	kCFRemoveBtn			'BRem'
#define	kCFAddEntryBtn			'BAdd'
#define	kCFScrollBar			'SBar'
#define	kCFUserPane				'Pane'
#define	kCFSheetAddrTxt			'AEad'
#define	kCFSheetCurrentValueTxt	'AEcv'
#define	kCFSheetCheetValueTxt	'AEtx'
#define	kCFSheetAddBtn			'SHTa'
#define	kCFSheetCancelBtn		'SHTc'

#define	kCFHexadecimal			1
#define	kCFSignedDecimal		2	
#define	kCFUnsignedDecimal		3

#define	kCFCompWithStored		1
#define	kCFCompWithLast			2
#define	kCFCompWithThis			3

#define	kCFSearchEqual			1
#define	kCFSearchNotEqual		2
#define	kCFSearchGreater		3
#define	kCFSearchGreaterOrEqual	4
#define	kCFSearchLess			5
#define	kCFSearchLessOrEqual	6

#define	kCFListItemHeight		13

Boolean				cfIsWatching;

static UInt8		*cfStoredRAM;
static UInt8		*cfLastRAM;
static UInt8		*cfCurrentRAM;
static UInt8		*cfStatusFlag;
static UInt32		*cfAddress;

static SInt32		cfNumRows;
static SInt32		cfListSelection;
static SInt32		cfListViewHeight;

static SInt32		cfViewMode;
static SInt32		cfCompMode;
static SInt32		cfCompWith;
static UInt32		cfViewNumBytes;
static UInt32		cfWatchAddr;
static Boolean		cfIsNewGame;
static Boolean		cfIsStored;

static char			cfWatchTextFormat[32];

static WindowRef	cfWRef, cfSheetRef;
static ControlRef	userPane, scrollBar;

extern SCheatData	Cheat;

void DisplayChar(uint8 *, uint8);

void InitCheatFinder(void)
{
	cfStoredRAM  = new UInt8  [MAIN_MEMORY_SIZE + 10];
	cfLastRAM    = new UInt8  [MAIN_MEMORY_SIZE + 10];
	cfCurrentRAM = new UInt8  [MAIN_MEMORY_SIZE + 10];
	cfStatusFlag = new UInt8  [MAIN_MEMORY_SIZE + 10];
	cfAddress    = new UInt32 [MAIN_MEMORY_SIZE + 10];
	
	if (!cfStoredRAM || !cfLastRAM || !cfCurrentRAM || !cfStatusFlag || !cfAddress)
		ExitToShell();
		
	memset(cfCurrentRAM, 0x00, MAIN_MEMORY_SIZE + 10);

	cfViewMode     = kCFUnsignedDecimal;
	cfViewNumBytes = 2;
	cfCompMode     = kCFSearchEqual;
	cfCompWith     = kCFCompWithThis;
}

void ResetCheatFinder(void)
{	
	memset(cfStoredRAM,  0x00, MAIN_MEMORY_SIZE);
	memset(cfLastRAM,    0x00, MAIN_MEMORY_SIZE);
	memset(cfStatusFlag, 0xFF, MAIN_MEMORY_SIZE);
	
	cfWatchAddr  = 0;
	cfIsNewGame  = true;
	cfIsWatching = false;
	cfIsStored   = false;
	
	CheatFinderMakeValueFormat(cfWatchTextFormat);
}

void DeinitCheatFinder(void)
{
	delete [] cfStoredRAM;
	delete [] cfLastRAM;
	delete [] cfCurrentRAM;
	delete [] cfStatusFlag;
	delete [] cfAddress;
}

void CheatFinder(void)
{
	OSStatus					err;
	IBNibRef					nibRef;
	CGrafPtr					oldPort;
	ControlRef					control;
	ControlID					controlID;
	Rect						bounds;
	MenuRef						menu;
	EventHandlerRef				eref, sEref;
	EventHandlerUPP				eventUPP, sEventUPP;
	EventTypeSpec				windowEvents[] = { { kEventClassCommand, kEventCommandProcess    }, 
												   { kEventClassWindow,  kEventWindowClose       },
												   { kEventClassWindow,  kEventWindowDrawContent },
												   { kEventClassWindow,  kEventWindowActivated   },
												   { kEventClassWindow,  kEventWindowDeactivated } },
								sheetEvents[]  = { { kEventClassCommand, kEventCommandProcess    } };
	ControlUserPaneDrawUPP		cfListDrawProc;
	ControlUserPaneHitTestUPP	cfListHitTestProc;
	ControlUserPaneTrackingUPP	cfListTrackingProc;
	ControlActionUPP			cfScrollBarActionProc;
	char						num[256], numP[256];
	int							i;

	if (!cartOpen)
		return;

	err = CreateNibReference(CFSTR("SNES9X"), &nibRef);
	if (err)
		return;
	
	err = CreateWindowFromNib(nibRef, CFSTR("CheatFinder"), &cfWRef);
	if (err)
		return;
		
	err = CreateWindowFromNib(nibRef, CFSTR("CFAddEntry"), &cfSheetRef);
	if (err)
		return;
		
	memcpy(cfCurrentRAM, Memory.RAM, MAIN_MEMORY_SIZE);
	CheatFinderBuildResultList();

	GetPort(&oldPort);
	SetPortWindowPort(cfWRef);
	
	controlID.id = 0;
	
	// User Pane & Scroll Bar
	
	controlID.signature = kCFUserPane;
	GetControlByID(cfWRef, &controlID, &userPane);
	controlID.signature = kCFScrollBar;
	GetControlByID(cfWRef, &controlID, &scrollBar);
	
	GetControlBounds(userPane, &bounds);
	cfListViewHeight = (bounds.bottom - bounds.top) / kCFListItemHeight;
	
	cfListDrawProc = NewControlUserPaneDrawUPP(CheatFinderListDrawProc);
	cfListHitTestProc = NewControlUserPaneHitTestUPP(CheatFinderListHitTestProc);
	cfListTrackingProc = NewControlUserPaneTrackingUPP(CheatFinderListTrackingProc);
	cfScrollBarActionProc = NewControlActionUPP(CheatFinderScrollbarActionProc);
	
	SetControlData(userPane, kControlEntireControl, kControlUserPaneDrawProcTag,     sizeof(ControlUserPaneDrawUPP),     &cfListDrawProc);
	SetControlData(userPane, kControlEntireControl, kControlUserPaneHitTestProcTag,  sizeof(ControlUserPaneHitTestUPP),  &cfListHitTestProc);
	SetControlData(userPane, kControlEntireControl, kControlUserPaneTrackingProcTag, sizeof(ControlUserPaneTrackingUPP), &cfListTrackingProc);
	SetControlAction(scrollBar, cfScrollBarActionProc);
	
	SetControl32BitMinimum(scrollBar, 0);
	SetControl32BitMaximum(scrollBar, (cfNumRows - cfListViewHeight > 0) ? (cfNumRows - cfListViewHeight) : 0);
	SetControl32BitValue(scrollBar, 0);
	SetControlViewSize(scrollBar, cfListViewHeight);
	
	//
		
	controlID.signature = kCFNumBytesPop;
	GetControlByID(cfWRef, &controlID, &control);
	menu = GetControlPopupMenuHandle(control);
	for (i = 1; i <= 4; i++)
		CheckMenuItem(menu, i, false);
	CheckMenuItem(menu, cfViewNumBytes, true);
	SetControl32BitValue(control, cfViewNumBytes);
	
	controlID.signature = kCFViewModeRad;
	GetControlByID(cfWRef, &controlID, &control);
	SetControl32BitValue(control, cfViewMode);
	
	controlID.signature = kCFCompModePop;
	GetControlByID(cfWRef, &controlID, &control);
	menu = GetControlPopupMenuHandle(control);
	for (i = 1; i <= 6; i++)
		CheckMenuItem(menu, i, false);
	CheckMenuItem(menu, cfCompMode, true);
	SetControl32BitValue(control, cfCompMode);
	
	if (cfIsNewGame || (!cfIsStored && (cfCompWith == kCFCompWithStored)))
		cfCompWith = kCFCompWithThis;
	
	controlID.signature = kCFCompStoredRad;
	GetControlByID(cfWRef, &controlID, &control);
	SetControl32BitValue(control, cfCompWith == kCFCompWithStored);
	if (cfIsStored)
		ActivateControl(control);
	else
		DeactivateControl(control);
	
	controlID.signature = kCFCompLastRad;
	GetControlByID(cfWRef, &controlID, &control);
	SetControl32BitValue(control, cfCompWith == kCFCompWithLast);
	if (!cfIsNewGame)
		ActivateControl(control);
	else
		DeactivateControl(control);

	controlID.signature = kCFCompThisRad;
	GetControlByID(cfWRef, &controlID, &control);
	SetControl32BitValue(control, cfCompWith == kCFCompWithThis);
	
	controlID.signature = kCFCompValueTxt;
	GetControlByID(cfWRef, &controlID, &control);
	SetEditTextText(control, "\p", false);
	
	controlID.signature = kCFWatchBtn;
	GetControlByID(cfWRef, &controlID, &control);
	SetControl32BitValue(control, cfIsWatching);
	
	controlID.signature = kCFWatchAddrTxt;
	GetControlByID(cfWRef, &controlID, &control);
	if (cfIsWatching)
	{
		sprintf(num, "%06lX", cfWatchAddr + 0x7E0000);
		ConvertCString(num, numP);
		SetStaticTextText(control, numP, false);
	}
	else
		SetStaticTextText(control, "\p", false);
		
	CheatFinderAdjustButtons();

	err = InstallStandardEventHandler(GetWindowEventTarget(cfWRef));
	eventUPP = NewEventHandlerUPP(CheatFinderEventHandler);
	err = InstallWindowEventHandler(cfWRef, eventUPP, 5, windowEvents, (void *) cfWRef, &eref);
	
	sEventUPP = NewEventHandlerUPP(CheatFinderSheetEventHandler);
	err = InstallWindowEventHandler(cfSheetRef, sEventUPP, 1, sheetEvents, (void *) cfSheetRef, &sEref);

	AdvanceKeyboardFocus(cfWRef);

	ShowWindow(cfWRef);
	err = RunAppModalLoopForWindow(cfWRef);
	HideWindow(cfWRef);
	
	err = RemoveEventHandler(sEref);
	DisposeEventHandlerUPP(sEventUPP);

	err = RemoveEventHandler(eref);
	DisposeEventHandlerUPP(eventUPP);
	
	DisposeControlUserPaneDrawUPP(cfListDrawProc);
	DisposeControlUserPaneHitTestUPP(cfListHitTestProc);
	DisposeControlUserPaneTrackingUPP(cfListTrackingProc);
	DisposeControlActionUPP(cfScrollBarActionProc);
	
	DisposeWindow(cfSheetRef);
	DisposeWindow(cfWRef);
	DisposeNibReference(nibRef);
	
	SetPort(oldPort);

	memcpy(cfLastRAM, Memory.RAM, MAIN_MEMORY_SIZE);	
	cfIsNewGame = false;
}

SInt64 CheatFinderReadBytes(UInt8 *mem, UInt32 addr)
{
	switch (cfViewMode)
	{
		case kCFSignedDecimal:
		{
			switch (cfViewNumBytes)
			{
				case 1:
					return (SInt64) (SInt8)   mem[addr];
					
				case 2:
					return (SInt64) (SInt16) (mem[addr] | (mem[addr + 1] << 8));
					
				case 4:
					return (SInt64) (SInt32) (mem[addr] | (mem[addr + 1] << 8) | (mem[addr + 2] << 16) | (mem[addr + 3] << 24));
	
				case 3:
					return (SInt64) (((SInt32) ((mem[addr] | (mem[addr + 1] << 8) | (mem[addr + 2] << 16)) << 8)) >> 8);
			}
		}
		
		break;
		
		case kCFUnsignedDecimal:
		case kCFHexadecimal:
		{
			switch (cfViewNumBytes)
			{
				case 1:
					return (SInt64) (UInt8)   mem[addr];
					
				case 2:
					return (SInt64) (UInt16) (mem[addr] | (mem[addr + 1] << 8));
					
				case 3:
					return (SInt64) (UInt32) (mem[addr] | (mem[addr + 1] << 8) | (mem[addr + 2] << 16));
					
				case 4:
					return (SInt64) (UInt32) (mem[addr] | (mem[addr + 1] << 8) | (mem[addr + 2] << 16) | (mem[addr + 3] << 24));
			}
		}
	}
	
	return 0;
}

pascal OSStatus CheatFinderEventHandler(EventHandlerCallRef inHandlerCallRef, EventRef inEvent, void *inUserData)
{
	#pragma unused (inHandlerCallRef)
	
	OSStatus	err, result;
	WindowRef	tWindowRef;
	ControlRef	control, ctl;
	ControlID	controlID, cid;
	CGrafPtr	oldPort;
	Rect		rct;
	char		num[256], numP[256];
	Boolean		update = false;

	result = eventNotHandledErr;
	tWindowRef = (WindowRef) inUserData;
	
	switch (GetEventClass(inEvent))
	{
		case kEventClassWindow:
			switch (GetEventKind(inEvent))
			{
				case kEventWindowClose:
					QuitAppModalLoopForWindow(tWindowRef);
					result = noErr;
					
					break;
					
				case kEventWindowDrawContent:
					GetControlBounds(userPane, &rct);
					rct.right += 15;
					DrawThemeListBoxFrame(&rct, IsWindowActive(tWindowRef) ? kThemeStateActive : kThemeStateInactive);
					result = noErr;
					
					break;

				case kEventWindowActivated:
					GetPort(&oldPort);
					SetPortWindowPort(tWindowRef);
					GetControlBounds(userPane, &rct);
					rct.right += 15;
					DrawThemeListBoxFrame(&rct, kThemeStateActive);
					SetPort(oldPort);
					result = noErr;
					
					break;

				case kEventWindowDeactivated:
					GetPort(&oldPort);
					SetPortWindowPort(tWindowRef);
					GetControlBounds(userPane, &rct);
					rct.right += 15;
					DrawThemeListBoxFrame(&rct, kThemeStateInactive);
					SetPort(oldPort);
					result = noErr;
			}
			
			break;

		case kEventClassCommand:
			switch (GetEventKind(inEvent))
			{
				case kEventCommandProcess:
					HICommand	tHICommand;

					err = GetEventParameter(inEvent, kEventParamDirectObject, typeHICommand, nil, sizeof(HICommand), nil, &tHICommand);
					if (err == noErr)
					{
						controlID.id = 0;
						controlID.signature = tHICommand.commandID;
						GetControlByID(tWindowRef, &controlID, &control);
						
						switch (tHICommand.commandID)
						{
							case kCFNumBytesPop:
								cfViewNumBytes = GetControl32BitValue(control);
								update = true;
								result = noErr;
								
								break;
								
							case kCFViewModeRad:
								cfViewMode     = GetControl32BitValue(control);
								update = true;
								result = noErr;
								
								break;
								
							case kCFCompModePop:
								cfCompMode     = GetControl32BitValue(control);
								result = noErr;
								
								break;
								
							case kCFCompStoredRad:		// Begin : Compare Radio Buttons
							case kCFCompLastRad:
							case kCFCompThisRad:
								if (tHICommand.commandID == kCFCompStoredRad)
									cfCompWith = kCFCompWithStored;
								else
								if (tHICommand.commandID == kCFCompLastRad)
									cfCompWith = kCFCompWithLast;
								else
									cfCompWith = kCFCompWithThis;
								
								cid.id = 0;
								
								cid.signature = kCFCompStoredRad;
								GetControlByID(tWindowRef, &cid, &ctl);
								SetControl32BitValue(ctl, cfCompWith == kCFCompWithStored);
								
								cid.signature = kCFCompLastRad;
								GetControlByID(tWindowRef, &cid, &ctl);
								SetControl32BitValue(ctl, cfCompWith == kCFCompWithLast);

								cid.signature = kCFCompThisRad;
								GetControlByID(tWindowRef, &cid, &ctl);
								SetControl32BitValue(ctl, cfCompWith == kCFCompWithThis);
								
								result = noErr;

								break;					// End

							case kCFStoreValueBtn:
								memcpy(cfStoredRAM, Memory.RAM, MAIN_MEMORY_SIZE);
								cfIsStored = true;
								
								cid.id = 0;
								cid.signature = kCFCompStoredRad;
								GetControlByID(tWindowRef, &cid, &ctl);
								ActivateControl(ctl);

								result = noErr;

								break;
								
							case kCFSearchBtn:
								CheatFinderSearch();
								update = true;
								result = noErr;
								
								break;
								
							case kCFRemoveBtn:
								CheatFinderRemoveFromList();
								update = true;
								result = noErr;
								
								break;
								
							case kCFRestoreBtn:
								CheatFinderRestoreList();
								update = true;
								result = noErr;
								
								break;
								
							case kCFAddEntryBtn:
								CheatFinderHandleAddEntryButton();
								result = noErr;

								break;
								
							case kCFWatchBtn:
								cid.id = 0;
								cid.signature = kCFWatchAddrTxt;
								GetControlByID(tWindowRef, &cid, &ctl);
									
								if (!cfIsWatching)
								{
									if (cfAddress[cfListSelection] > (0x20000 - cfViewNumBytes))
									{
										SysBeep(10);
										SetControl32BitValue(control, 0);
									}
									else
									{									
										cfWatchAddr = cfAddress[cfListSelection];
										cfIsWatching = true;
										
										sprintf(num, "%06lX", cfWatchAddr + 0x7E0000);
										ConvertCString(num, numP);
										SetStaticTextText(ctl, numP, true);
									}
								}
								else
								{
									cfWatchAddr = 0;
									cfIsWatching = false;
									
									SetControl32BitValue(control, 0);
									SetStaticTextText(ctl, "\p", true);
									
									CheatFinderAdjustButtons();
								}
								
								result = noErr;								
						}
						
						if (update)
						{						
							Draw1Control(userPane);
							CheatFinderAdjustButtons();
						}
						
						CheatFinderMakeValueFormat(cfWatchTextFormat);
					}
			}
	}
	
	return result;
}

SInt64 CheatFinderGetValueEditText(ControlRef control)
{
	SInt64		result = 0;
	UInt32		uvalue;
	SInt32		svalue;	
	Str255		numP;
	char		num[256];
	
	GetEditTextText(control, numP);
	if (numP[0] == 0)
	{
		SetEditTextText(control, "\p0", true);
		return 0;
	}

	ConvertPString(numP, num);
	
	switch (cfViewMode)
	{
		case kCFSignedDecimal:
			if (sscanf(num, "%ld", &svalue) == 1)
			{
				switch (cfViewNumBytes)
				{
					case 1:
						if (svalue >  127)
						{
							svalue =  127;
							SetEditTextText(control, "\p127", true);
						}
						else
						if (svalue < -128)
						{
							svalue = -128;
							SetEditTextText(control, "\p-128", true);
						}
						
						break;
						
					case 2:
						if (svalue >  32767)
						{
							svalue =  32767;
							SetEditTextText(control, "\p32767", true);
						}
						else
						if (svalue < -32768)
						{
							svalue = -32768;
							SetEditTextText(control, "\p-32768", true);
						}
						
						break;
						
					case 3:
						if (svalue >  8388607)
						{
							svalue =  8388607;
							SetEditTextText(control, "\p8388607", true);
						}
						else
						if (svalue < -8388608)
						{
							svalue = -8388608;
							SetEditTextText(control, "\p-8388608", true);
						}
				}
			}
			else
			{
				svalue = 0;
				SetEditTextText(control, "\p0", true);
			}
			
			result = (SInt64) svalue;
			
			break;
			
		case kCFUnsignedDecimal:
			if (sscanf(num, "%lu", &uvalue) == 1)
			{
				switch (cfViewNumBytes)
				{
					case 1:
						if (uvalue > 255)
						{
							uvalue = 255;
							SetEditTextText(control, "\p255", true);
						}
						
						break;
						
					case 2:
						if (uvalue > 65535)
						{
							uvalue = 65535;
							SetEditTextText(control, "\p65535", true);
						}
						
						break;
						
					case 3:
						if (uvalue > 16777215)
						{
							uvalue = 16777215;
							SetEditTextText(control, "\p16777215", true);
						}
				}
			}
			else
			{
				uvalue = 0;
				SetEditTextText(control, "\p0", true);
			}
			
			result = (SInt64) uvalue;
			
			break;
			
		case kCFHexadecimal:
			if (sscanf(num, "%lx", &uvalue) == 1)
			{
				switch (cfViewNumBytes)
				{
					case 1:
						if (uvalue > 0xFF)
						{
							uvalue = 0xFF;
							SetEditTextText(control, "\pFF", true);
						}
						
						break;
						
					case 2:
						if (uvalue > 0xFFFF)
						{
							uvalue = 0xFFFF;
							SetEditTextText(control, "\pFFFF", true);
						}
						
						break;
						
					case 3:
						if (uvalue > 0xFFFFFF)
						{
							uvalue = 0xFFFFFF;
							SetEditTextText(control, "\pFFFFFF", true);
						}
				}
			}
			else
			{
				uvalue = 0;
				SetEditTextText(control, "\p0", true);
			}
			
			result = (SInt64) uvalue;
	}
	
	return result;
}

void CheatFinderSearch(void)
{
	UInt8	*mem;
	SInt64	cmpvalue;
	SInt32	i;
	
	if (cfCompWith == kCFCompWithThis)
	{
		ControlRef	ctl;
		ControlID	cid = { kCFCompValueTxt, 0 }; 
		
		GetControlByID(cfWRef, &cid, &ctl);
		cmpvalue = CheatFinderGetValueEditText(ctl);
			
		for (i = 0; i < cfNumRows; i++)
			if (!CheatFinderCompare(CheatFinderReadBytes(cfCurrentRAM, cfAddress[i]), cmpvalue))
				cfStatusFlag[cfAddress[i]] = 0;
	}
	else
	{
		mem = (cfCompWith == kCFCompWithStored) ? cfStoredRAM : cfLastRAM;
	
		for (i = 0; i < cfNumRows; i++)
			if (!CheatFinderCompare(CheatFinderReadBytes(cfCurrentRAM, cfAddress[i]), CheatFinderReadBytes(mem, cfAddress[i])))
				cfStatusFlag[cfAddress[i]] = 0;
	}
	
	CheatFinderBuildResultList();	

	SetControl32BitMaximum(scrollBar, (cfNumRows - cfListViewHeight > 0) ? (cfNumRows - cfListViewHeight) : 0);
	SetControl32BitValue(scrollBar, 0);
}

Boolean CheatFinderCompare(SInt64 ramvalue, SInt64 cmpvalue)
{
	switch (cfCompMode)
	{
		case kCFSearchEqual:
			return (ramvalue == cmpvalue);
			
		case kCFSearchNotEqual:
			return (ramvalue != cmpvalue);
			
		case kCFSearchGreater:
			return (ramvalue >  cmpvalue);
			
		case kCFSearchGreaterOrEqual:
			return (ramvalue >= cmpvalue);
			
		case kCFSearchLess:
			return (ramvalue <  cmpvalue);
			
		case kCFSearchLessOrEqual:
			return (ramvalue <= cmpvalue);
	}
	
	return false;
}

pascal void CheatFinderListDrawProc(ControlRef control, SInt16 part)
{
	#pragma unused (part)
	
	ThemeDrawingState	state;
	GDHandle			gdh;
	CGrafPtr			oldPort;
	Rect				bounds, rct;
	SInt32				topIdx;
	SInt16				inDepth;
	Boolean				inIsColorDevice;
	char				text[256], code[256], format[32], spc[32];
	
	GetPort(&oldPort);
	SetPortWindowPort(cfWRef);
	
	topIdx = GetControl32BitValue(scrollBar);
	GetControlBounds(control, &bounds);

	gdh = GetGDevice();
	inDepth = (**((**gdh).gdPMap)).pixelSize;
	inIsColorDevice = ((1 << gdDevType) & (**gdh).gdFlags) != 0;
	
	GetThemeDrawingState(&state);

	SetThemeBackground(kThemeBrushListViewBackground, inDepth, inIsColorDevice);
	bounds.top++;
	EraseRect(&bounds);
	bounds.top--;
	
	TextFont(kFontIDMonaco);
	TextSize(9);
	
	for (SInt32 i = topIdx; i < topIdx + cfListViewHeight; i++)
	{
		if (i < cfNumRows)
		{
			CheatFinderMakeValueFormat(format);
			sprintf(code, format, CheatFinderReadBytes(cfCurrentRAM, cfAddress[i]));
			
			rct.top    = bounds.top + ((i - topIdx) * kCFListItemHeight) + 1;
			rct.bottom = rct.top    + kCFListItemHeight;
			
			if (i == cfListSelection)
			{
				rct.left  = bounds.left  + 1;
				rct.right = bounds.right - 1;
				SetThemeBackground(kThemeBrushPrimaryHighlightColor, inDepth, inIsColorDevice);
				EraseRect(&rct);
			}
			
			sprintf(text, "%06lX", cfAddress[i] + 0x7E0000);
			strcpy(spc, "                              ");
			spc[21 - strlen(code)] = 0;
			strcat(text, spc);
			strcat(text, code);
			rct.left  = bounds.left + 4;
			rct.top  += 10;
			MoveTo(rct.left, rct.top);
			DrawText(text, 0, strlen(text));
			
			if (i == cfListSelection)
				SetThemeBackground(kThemeBrushListViewBackground,    inDepth, inIsColorDevice);
		}
	}
	
	TextFont(0);
	TextSize(0);

	SetThemeDrawingState(state, true);	
	SetPort(oldPort);
}

pascal ControlPartCode CheatFinderListHitTestProc(ControlRef control, Point where)
{
	Rect	rct;
	
	GetControlBounds(control, &rct);
	
	return PtInRect(where, &rct) ? 1 : kControlNoPart;
}

pascal ControlPartCode CheatFinderListTrackingProc(ControlRef control, Point startPt, ControlActionUPP actionProc)
{
	#pragma unused (actionProc)
	
	MouseTrackingResult	trackingResult;
	SInt32				newSelection;
	Rect				rct;
	Point				pt;
	
	GetControlBounds(control, &rct);
	pt = startPt;

	do
	{
		if (PtInRect(pt, &rct))
		{
			pt.h -= rct.left;
			pt.v -= rct.top;
			
			newSelection = (pt.v / kCFListItemHeight) + GetControl32BitValue(scrollBar);			
			if (newSelection >= cfNumRows)
				newSelection = cfNumRows - 1;
			
			if (cfListSelection != newSelection)
			{
				cfListSelection = newSelection;
				Draw1Control(control);
			}
		}
		
		TrackMouseLocation(nil, &pt, &trackingResult);
	}
	while (trackingResult != kMouseTrackingMouseUp);

	return PtInRect(pt, &rct) ? 1 : kControlNoPart;
}

pascal void CheatFinderScrollbarActionProc(ControlRef control, ControlPartCode partCode)
{
	SInt32	newValue, maxValue, viewSize;
	Boolean	dirty = true;
	
	static SInt32	oldValue = 0xDEADBEEF;
	
	newValue = GetControl32BitValue(control);
	maxValue = GetControl32BitMaximum(control);
	viewSize = GetControlViewSize(control);
	
	switch (partCode)
	{
		case kControlUpButtonPart:
			newValue--;
			break;
		
		case kControlDownButtonPart:
			newValue++;
			break;
		
		case kControlPageUpPart:
			newValue -= viewSize;
			break;
		
		case kControlPageDownPart:
			newValue += viewSize;
			break;
		
		default:
			dirty = false;
	}
	
	if (newValue < 0)
		newValue = 0;
	if (newValue > maxValue)
		newValue = maxValue;
	
	if (newValue != oldValue)
	{
		if (dirty)
			SetControl32BitValue(scrollBar, newValue);

		Draw1Control(userPane);
	}
	
	oldValue = newValue;
}

void CheatFinderBuildResultList(void)
{
	cfNumRows = 0;
	
	for (int i = 0; i < MAIN_MEMORY_SIZE; i++)
	{
		if (cfStatusFlag[i] == 0xFF)
		{
			cfAddress[cfNumRows] = i;
			cfNumRows++;
		}
	}
	
	cfListSelection = 0;
}

void CheatFinderAdjustButtons(void)
{
	ControlRef	ctl;
	ControlID	cid;
	
	cid.id = 0;
		
	if (cfNumRows > 0)	// means an item is selected
	{		
		cid.signature = kCFAddEntryBtn;
		GetControlByID(cfWRef, &cid, &ctl);
		ActivateControl(ctl);
		
		cid.signature = kCFRemoveBtn;
		GetControlByID(cfWRef, &cid, &ctl);
		ActivateControl(ctl);

		cid.signature = kCFWatchBtn;
		GetControlByID(cfWRef, &cid, &ctl);
		ActivateControl(ctl);
	}
	else				// no item is selected
	{		
		cid.signature = kCFAddEntryBtn;
		GetControlByID(cfWRef, &cid, &ctl);
		DeactivateControl(ctl);
		
		cid.signature = kCFRemoveBtn;
		GetControlByID(cfWRef, &cid, &ctl);
		DeactivateControl(ctl);

		if (!cfIsWatching)
		{
			cid.signature = kCFWatchBtn;
			GetControlByID(cfWRef, &cid, &ctl);
			DeactivateControl(ctl);
		}
	}
}

void CheatFinderRemoveFromList(void)
{
	if (cfNumRows > 0)
	{
		cfStatusFlag[cfAddress[cfListSelection]] = 0;

		if (cfNumRows == 1)
		{			
			cfNumRows = 0;
			
			SetControl32BitMaximum(scrollBar, 0);
			SetControl32BitValue(scrollBar, 0);
		}
		else
		{
			for (SInt32 i = cfListSelection; i < cfNumRows - 1; i++)
				cfAddress[i] = cfAddress[i + 1];
			
			cfNumRows--;
			if (cfListSelection >= cfNumRows)
				cfListSelection = cfNumRows - 1;
			
			if (cfNumRows - cfListViewHeight > 0)
				SetControl32BitMaximum(scrollBar, cfNumRows - cfListViewHeight);
			else
			{
				SetControl32BitMaximum(scrollBar, 0);
				SetControl32BitValue(scrollBar, 0);
			}
		}
	}
}

void CheatFinderRestoreList(void)
{
	memset(cfStatusFlag, 0xFF, MAIN_MEMORY_SIZE);
	CheatFinderBuildResultList();	

	SetControl32BitMaximum(scrollBar, (cfNumRows - cfListViewHeight > 0) ? (cfNumRows - cfListViewHeight) : 0);
	SetControl32BitValue(scrollBar, 0);
}

void CheatFinderMakeValueFormat(char *text)
{
	switch (cfViewMode)
	{
		case kCFSignedDecimal:
		case kCFUnsignedDecimal:
			strcpy(text, "%lld");
			break;
		
		case kCFHexadecimal:
			sprintf(text, "%%0%lullX", cfViewNumBytes * 2);
	}
}		

void CheatFinderDrawWatchAddr(void)
{
	uint8	*basePtr;
	int		len, i;
	
	static char	code[256];
	
	sprintf(code, cfWatchTextFormat, CheatFinderReadBytes(Memory.RAM, cfWatchAddr));

	basePtr = GFX.Screen + (Settings.SixteenBit ? 2 : 1);
	len = strlen(code);
	
	for (i = 0; i < len; i++)
	{
		DisplayChar(basePtr, code[i]);
		basePtr += Settings.SixteenBit ? (font_width - 1) * 2 : (font_width - 1);
    }
}

void CheatFinderHandleAddEntryButton(void)
{
	if (cfAddress[cfListSelection] > (0x20000 - cfViewNumBytes))	
		SysBeep(10);
	else
	if (Cheat.num_cheats + cfViewNumBytes > MAX_CHEATS)
		AppearanceAlert(kAlertCautionAlert, kCFCantAddWarning, kCFCantAddHint);
	else
		CheatFinderBeginAddEntrySheet();
}

void CheatFinderBeginAddEntrySheet(void)
{
	OSStatus	err;
	ControlRef	ctl;
	ControlID	cid;
	UInt32		addr;
	char		buf1[256], buf2[256];
	
	addr = cfAddress[cfListSelection];
	
	cid.id = 0;
	
	cid.signature = kCFSheetAddrTxt;
	GetControlByID(cfSheetRef, &cid, &ctl);
	sprintf(buf1, "%06lX", addr + 0x7E0000);
	ConvertCString(buf1, buf2);
	SetStaticTextText(ctl, buf2, false);
	
	cid.signature = kCFSheetCurrentValueTxt;
	GetControlByID(cfSheetRef, &cid, &ctl);
	CheatFinderMakeValueFormat(buf2);
	sprintf(buf1, buf2, CheatFinderReadBytes(cfCurrentRAM, addr));
	ConvertCString(buf1, buf2);
	SetStaticTextText(ctl, buf2, false);

	cid.signature = kCFSheetCheetValueTxt;
	GetControlByID(cfSheetRef, &cid, &ctl);
	SetEditTextText(ctl, buf2, false);	
	SetKeyboardFocus(cfSheetRef, ctl, kControlEditTextPart);
	
	err = ShowSheetWindow(cfSheetRef, cfWRef);

	SetEditTextSelection(ctl, 0, 32767);
}

pascal OSStatus CheatFinderSheetEventHandler(EventHandlerCallRef inHandlerCallRef, EventRef inEvent, void *inUserData)
{
	#pragma unused (inHandlerCallRef)
	
	OSStatus	err, result;
	WindowRef	tWindowRef;

	result = eventNotHandledErr;
	tWindowRef = (WindowRef) inUserData;
	
	switch (GetEventClass(inEvent))
	{
		case kEventClassCommand:
			switch (GetEventKind(inEvent))
			{
				case kEventCommandProcess:
					HICommand	tHICommand;

					err = GetEventParameter(inEvent, kEventParamDirectObject, typeHICommand, nil, sizeof(HICommand), nil, &tHICommand);
					if (err == noErr)
					{
						switch (tHICommand.commandID)
						{
							case kCFSheetAddBtn:
								ControlRef	ctl;
								ControlID	cid;
							
								cid.id = 0;
								cid.signature = kCFSheetCheetValueTxt;		
								GetControlByID(tWindowRef, &cid, &ctl);
								CheatFinderAddEntry(CheatFinderGetValueEditText(ctl));
								
								err = HideSheetWindow(tWindowRef);								
								result = noErr;

								break;
								
							case kCFSheetCancelBtn:
								err = HideSheetWindow(tWindowRef);								
								result = noErr;
						}
					}
			}
	}
	
	return result;
}	

void CheatFinderAddEntry(SInt64 value)
{
	UInt32	addr, v, i;
	char	description[22];
	
	addr = cfAddress[cfListSelection];
	v = (UInt32) (SInt32) value;

	for (i = 0; i < cfViewNumBytes; i++)
	{
		sprintf(description, "CF(%06lX-%06lX)%ld", addr + 0x7E0000, addr + cfViewNumBytes - 1 + 0x7E0000, i + 1);
		strcpy(Cheat.c[Cheat.num_cheats].name, description);			
		S9xAddCheat(true, true, addr + i + 0x7E0000, (UInt8) ((v & (0x000000FF << (i * 8))) >> (i * 8)));
	}
	
	S9xApplyCheats();
}
