/*******************************************************************************
  Snes9x - Portable Super Nintendo Entertainment System (TM) emulator.
 
  (c) Copyright 1996 - 2003 Gary Henderson (gary.henderson@ntlworld.com) and
                            Jerremy Koot (jkoot@snes9x.com)

  (c) Copyright 2002 - 2003 Matthew Kendora and
                            Brad Jorsch (anomie@users.sourceforge.net)
 

                      
  C4 x86 assembler and some C emulation code
  (c) Copyright 2000 - 2003 zsKnight (zsknight@zsnes.com),
                            _Demo_ (_demo_@zsnes.com), and
                            Nach (n-a-c-h@users.sourceforge.net)
                                          
  C4 C++ code
  (c) Copyright 2003 Brad Jorsch

  DSP-1 emulator code
  (c) Copyright 1998 - 2003 Ivar (ivar@snes9x.com), _Demo_, Gary Henderson,
                            John Weidman (jweidman@slip.net),
                            neviksti (neviksti@hotmail.com), and
                            Kris Bleakley (stinkfish@bigpond.com)
 
  DSP-2 emulator code
  (c) Copyright 2003 Kris Bleakley, John Weidman, neviksti, Matthew Kendora, and
                     Lord Nightmare (lord_nightmare@users.sourceforge.net

  OBC1 emulator code
  (c) Copyright 2001 - 2003 zsKnight, pagefault (pagefault@zsnes.com)
  Ported from x86 assembler to C by sanmaiwashi

  SPC7110 and RTC C++ emulator code
  (c) Copyright 2002 Matthew Kendora with research by
                     zsKnight, John Weidman, and Dark Force

  S-RTC C emulator code
  (c) Copyright 2001 John Weidman
  
  Super FX x86 assembler emulator code 
  (c) Copyright 1998 - 2003 zsKnight, _Demo_, and pagefault 

  Super FX C emulator code 
  (c) Copyright 1997 - 1999 Ivar and Gary Henderson.



 
  Specific ports contains the works of other authors. See headers in
  individual files.
 
  Snes9x homepage: http://www.snes9x.com
 
  Permission to use, copy, modify and distribute Snes9x in both binary and
  source form, for non-commercial purposes, is hereby granted without fee,
  providing that this license information and copyright notice appear with
  all copies and any derived work.
 
  This software is provided 'as-is', without any express or implied
  warranty. In no event shall the authors be held liable for any damages
  arising from the use of this software.
 
  Snes9x is freeware for PERSONAL USE only. Commercial users should
  seek permission of the copyright holders first. Commercial use includes
  charging money for Snes9x or software derived from Snes9x.
 
  The copyright holders request that bug fixes and improvements to the code
  should be forwarded to them so everyone can benefit from the modifications
  in future versions.
 
  Super NES and Super Nintendo Entertainment System are trademarks of
  Nintendo Co., Limited and its subsidiary companies.
*******************************************************************************/

/*******************************************************************************
  Snes9x custom (Snes9x for Mac OS X) by zones
  
  This build was started from John Stiles' port.
*******************************************************************************/

#include "mac-prefix.h"

#include <Carbon/Carbon.h>
#include <QuickTime/QuickTime.h>
#include <OpenGL/OpenGL.h>
#include <OpenGL/CGLRenderers.h>
#include <OpenGL/gl.h>
#include <OpenGL/glu.h>
#include <OpenGL/glext.h>
#include <AGL/agl.h>

#include <string.h>
#include <ctype.h>
#include <unistd.h>
#include <stdlib.h>
#include <pthread.h>

#include "snes9x.h"
#include "cheats.h"
#include "memmap.h"
#include "debug.h"
#include "ppu.h"
#include "snapshot.h"
#include "gfx.h"
#include "display.h"
#include "apu.h"
#include "cpuexec.h"
#include "soundux.h"

#include "mac-2xsai.h"
#include "mac-appleevent.h"
#include "mac-blit.h"
#include "mac-cheat.h"
#include "mac-cheatfinder.h"
#include "mac-dialog.h"
#include "mac-gworld.h"
#include "mac-joypad.h"
#include "mac-keyboard.h"
#include "mac-musicbox.h"
#include "mac-prefs.h"
#include "mac-snes9x.h"
#include "mac-stringtools.h"
#include "mac-os.h"

extern int	spc_is_dumping;
extern char	pfold[9];

pthread_t	s9xthread;
bool8		s9xthreadrunning = false;

SInt32	systemVersion;

uint32	controlPad[5];

uint8	romDetect        = kAutoROMType,
		interleaveDetect = kAutoInterleave;

int		imageWidth = 0, imageHeight = 0, imageDepth = 16;

#define kMaxSoundBuffers	120

int				macBufferSize = 2, macBufferCount = 36;
float			macSoundPitch = 1.0, macSoundPitchMaster = 1.0;
SInt32			macSoundVolume = 80;
int				soundBufferAt = -1, soundPlayAt = -1, soundQueued = 0;
char			*soundBuffer[kMaxSoundBuffers], *emptyBuffer;
SndChannelPtr	sndChannel;
ExtSoundHeader	sndHeader;
SndCallBackUPP	callBackUPP;

#define	kRecentMenu_MAX	20

CFStringRef	recentItem[kRecentMenu_MAX + 1];
MenuRef		recentMenu;

int		mac7110Load  = 1;
int		musicboxmode = kMBXSoundEmulation;

long	drawingMethod = kDrawingDirect;
long	lastDrawingMethod = 0;

bool8	finished        = false,
		cartOpen        = false,
		running         = false,
		directDisplay   = false,
		
		fullscreen      = true,
		autoRes         = false,
		glstretch       = true,
		glproportional  = true,
		gl32bit         = true,

		doubleSize      = true,
		tvMode          = false,
		smoothMode      = false,
		eagleMode       = false,
		saiMode         = false,

		mouseActive     = false,
		scopecursor     = true,

		multiprocessor  = false,
		vsync           = true,
		
		startopendlog   = true,
		showtimeinfrz   = true,
		allowevent      = true,
		
		autofire        = false,
		enabletoggle    = true,
	
		folderWarning   = false,
		lockedROMMedia  = false,
		hidExist        = true,
		applycheat      = false;
		
uint8	saveInROMFolder = 0; // 0 : SNES9X  1 : ROM  2 : Application Support
      
CTabHandle	myColorTable = nil;

int			frameCount = 0;
int64		lastFrame;

const int	kFastForwardRate = 5;
Boolean		gFastForward = false, gScopeTurbo = false;
int			toggleff = 0, togglescopeturbo = 0;

AutoFireState	autofireRec[5];

char	gPackFolderPath[PATH_MAX + 1];
char	gMacRomName[ROM_NAME_LEN];

typedef void (* Blitter) (register unsigned char *, register unsigned char *, register long, register Rect *, register Rect *);

Blitter	BlitFn256x240 = nil, BlitFn512x240 = nil, BlitFn512x480 = nil;

uint8	*gfxScreenA, *gfxScreenB, *snesScreenA, *snesScreenB, *blitGLBuffer;

unsigned long	spcFileCount = 0, pngFileCount = 0;
int				padSetting = 1, deviceSetting = 1;

unsigned char 	*gMacScreenPtr, *gWinScreenPtr;
long			gMacRowBytes;

struct MPData
{
	Blitter	blitFn;
	Rect	srcRect;
	Rect	copyRect;
	long	dstRowBytes;
	uint8	*gfxBuffer;
	uint8	*dstPtr;
};

MPTaskID		taskID            = nil;
MPQueueID		notificationQueue = nil;
MPQueueID		taskQueue         = nil;
MPSemaphoreID	readySemaphore    = nil;
MPData 			*mpDataBuffer     = nil;

enum
{
	kMPBlitFrame = 1,
	kMPBlitDone  = 2
};

CFDictionaryRef			oldDisplayMode;
CGLContextObj			glContext;
AGLContext 				agContext;
long 					glSwapInterval = 0;
GLint					agSwapInterval = 0;
WindowRef				gWindow = nil;
Rect					gWindowRect;
int						glScreenW, glScreenH;
EventHandlerUPP			gameWindowUPP;
EventHandlerRef			gameWindowEventRef;

typedef struct
{
    GLint	internal_format;
    GLint	format;
    GLint	type;
    GLuint	textures[8];
}	OpenGLData;

OpenGLData	OpenGL;

typedef struct
{
	int	globalLeft;
	int	globalTop;
	int	width;
	int	height;
}	GameViewInfo;

GameViewInfo	scopeViewInfo;

#define KeyIsPressed(km, k)	(1 & (((unsigned char *) km) [(k) >> 3] >> ((k) & 7)))

enum
{
	kmF1Key  = 0x7A,
	kmF2Key  = 0x78,
	kmF3Key	 = 0x63,
	kmF4Key	 = 0x76,
	kmF5Key	 = 0x60,
	kmEscKey = 0x35,
	kmCmdKey = 0x37,
	kmFKey   = 0x03,
	kmDKey   = 0x02,
	km1Key   = 0x12,
	km2Key   = 0x13,
	km3Key   = 0x14,
	km4Key   = 0x15,
	km5Key   = 0x17,
	km6Key   = 0x16,
	km7Key   = 0x1a,
	km8Key   = 0x1c,
	km9Key   = 0x19,
	kmAKey   = 0x00,
	kmBKey   = 0x0b,
	kmCKey   = 0x08,
	kmCtrKey = 0x3B
};

enum
{
	mApple          = 128,
	iAbout          = 1,
	
	mFile           = 129,
	iOpen           = 1,
	iOpenRecent     = 2,
	iRomInfo        = 4,
	
	mControl        = 134,
	iKeyboardLayout = 1,
	iISpLayout      = 2,
	iAutoFire       = 4,
	iISpPreset      = 6,
	
	mEdit           = 130,

	mEmulation      = 131,
	iResume         = 1,
	iSoftReset      = 3,
	iReset          = 4,
	iSwapPad        = 6,
	iScopeCursor    = 7,
	iDevice         = 9,
	
	mCheat          = 132,
	iApplyCheats    = 1,
	iGameGenie      = 3,
	iCheatFinder    = 4,

	mOption         = 133,
	iFreeze         = 1,
	iDefrost        = 2,
	iFreezeTo       = 4,
	iDefrostFrom    = 5,
	iSaveSPC        = 7,
	iSaveSRAM       = 8,
	iMusicBox       = 10,
	
	mPresets        = 201,
	
	mDevice         = 202,
	iPad            = 1,
	iMouse			= 2,
	iMouse2         = 3,
	iSuperScope     = 4,
	iMultiPlayer5   = 5,
	iJustifier1     = 6,
	iJustifier2     = 7,
	
	mRecentItem     = 203
};

void * MacSNES9XThread(void *p)
{
	#pragma unused (p)
	
	s9xthreadrunning = true;
	
	while (running)
	{
		ProcessInput();
		S9xMainLoop();
	}

	s9xthreadrunning = false;
	
	return nil;
}

int main(int argc, char *argv[])
{
 	#pragma unused (argc, argv)

	OSStatus		err;
	EventHandlerRef	eref;
	EventHandlerUPP	appEventHandler;
	EventTypeSpec	events[] = { { kEventClassCommand, kEventCommandProcess } };
	
	appEventHandler = NewEventHandlerUPP(MainEventHandler);
 	err = InstallApplicationEventHandler(appEventHandler, 1, events, nil, &eref);
	
	Initialize();
   	
	while (!finished)
	{
		if (cartOpen && running)
		{
			#ifdef DEBUGGER
				CPU.Flags |= DEBUG_MODE_FLAG;
				S9xDoDebug();
			#endif
			
			if (!allowevent || fullscreen || (drawingMethod == kDrawingDirect))
			{
				S9xInitDisplay(nil, nil);
				ClearGFXScreen();
				
				while (running)
				{
					ProcessInput();
					S9xMainLoop();
				}
				
				S9xDeinitDisplay();
			}
			else
			{
				CFStringRef	ref;
				MenuRef		menu;
				bool8		oldmouseActive;
				
				oldmouseActive = mouseActive;
				mouseActive = true;
				
				err = RemoveEventHandler(eref);
				DisposeEventHandlerUPP(appEventHandler);
				
				appEventHandler = NewEventHandlerUPP(SubEventHandler);
				err = InstallApplicationEventHandler(appEventHandler, 1, events, nil, &eref);
				
				S9xInitDisplay(nil, nil);
				ClearGFXScreen();

				menu = GetMenuHandle(mEmulation);
				
				ref = CFCopyLocalizedString(CFSTR("PauseMenu"), "pause");
				err = SetMenuItemTextWithCFString(menu, iResume, ref);
				CFRelease(ref);
				
				EnableMenuItem (menu, 0);
				EnableMenuItem (menu, iResume);
				DisableMenuItem(menu, iSoftReset);
				DisableMenuItem(menu, iReset);
				DisableMenuItem(menu, iSwapPad);
				DisableMenuItem(menu, iScopeCursor);
				DisableMenuItem(menu, iDevice);
				
				pthread_create(&s9xthread, nil, MacSNES9XThread, nil);
				printf("Emulation pthread : Created\n");
				
				RunApplicationEventLoop();
				
				pthread_join(s9xthread, nil);
				printf("Emulation pthread : Joined\n");
				
				EnableMenuItem(menu, iSoftReset);
				EnableMenuItem(menu, iReset);
				EnableMenuItem(menu, iSwapPad);
				EnableMenuItem(menu, iScopeCursor);
				EnableMenuItem(menu, iDevice);
				
				ref = CFCopyLocalizedString(CFSTR("RunMenu"), "run");
				err = SetMenuItemTextWithCFString(menu, iResume, ref);
				CFRelease(ref);
				
				S9xDeinitDisplay();

				err = RemoveEventHandler(eref);
				DisposeEventHandlerUPP(appEventHandler);
				
				appEventHandler = NewEventHandlerUPP(MainEventHandler);
				err = InstallApplicationEventHandler(appEventHandler, 1, events, nil, &eref);
				
				mouseActive = oldmouseActive;
			}
		}

		if (!finished)
		{
			EnableMenus();
			RunApplicationEventLoop();
		}
	}
	
	Deinitialize();
	
	err = RemoveEventHandler(eref);
 	DisposeEventHandlerUPP(appEventHandler);

	return 0;
}

pascal OSStatus MainEventHandler(EventHandlerCallRef inHandlerCallRef, EventRef inEvent, void *inUserData)
{
    #pragma unused (inHandlerCallRef, inUserData)
    
    OSStatus	err, result = eventNotHandledErr;
	Boolean		done = false;

	switch (GetEventClass(inEvent))
	{
		case kEventClassCommand:
			switch (GetEventKind(inEvent))
			{
				case kEventCommandProcess:
					HICommand	cmd;

					err = GetEventParameter(inEvent, kEventParamDirectObject, typeHICommand, nil, sizeof(HICommand), nil, &cmd);
					if (err == noErr)
					{
						result = HandleMenuChoice(cmd.commandID, &done);
						
						if (done)
							QuitApplicationEventLoop();
					}
			}
	}
	
	return result;
}

pascal OSStatus SubEventHandler(EventHandlerCallRef inHandlerCallRef, EventRef inEvent, void *inUserData)
{
    #pragma unused (inHandlerCallRef, inUserData)
    
    OSStatus	err, result = eventNotHandledErr;

	switch (GetEventClass(inEvent))
	{
		case kEventClassCommand:
			switch (GetEventKind(inEvent))
			{
				case kEventCommandProcess:
					HICommand	cmd;

					err = GetEventParameter(inEvent, kEventParamDirectObject, typeHICommand, nil, sizeof(HICommand), nil, &cmd);
					if (err == noErr)
					{
						switch (cmd.commandID)
						{
							case 'Erun':	// Pause
							case 'SubQ':	// Queue from emulation thread
								running = false;
								while (s9xthreadrunning)
									sleep(0);
								QuitApplicationEventLoop();
								result = noErr;
						}
					}
			}
	}
	
	return result;
}

void InitGameWindow(void)
{
	OSStatus		err;
	CFStringRef		ref;
	Rect			rct = { 0, 0, 480, 512 };
	char			drive[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], ext[_MAX_EXT];
	EventTypeSpec	windowEvents[] = { { kEventClassMouse,  kEventMouseUp } };
	
	if (gWindow)
		return;
	
	err = CreateNewWindow(kDocumentWindowClass, kWindowCollapseBoxAttribute | kWindowStandardHandlerAttribute, &rct, &gWindow);

	gameWindowUPP = NewEventHandlerUPP(GameWindowEventHandler);
	err = InstallWindowEventHandler(gWindow, gameWindowUPP, 1, windowEvents, (void *) gWindow, &gameWindowEventRef);
	
	_splitpath(Memory.ROMFilename, drive, dir, fname, ext);
	ref = CFStringCreateWithCString(kCFAllocatorDefault, fname, kCFStringEncodingUTF8);
	if (ref)
	{
		SetWindowTitleWithCFString(gWindow, ref);
		CFRelease(ref);
	}
		
	MoveWindow(gWindow, (CGDisplayPixelsWide(kCGDirectMainDisplay) - 512) >> 1, (CGDisplayPixelsHigh(kCGDirectMainDisplay) - 480) >> 1, true);
	ActivateWindow(gWindow, true);
	ShowWindow(gWindow);
}

void DeinitGameWindow(void)
{
	OSStatus	err;
	
	if (!gWindow)
		return;
	
	err = RemoveEventHandler(gameWindowEventRef);
	DisposeEventHandlerUPP(gameWindowUPP);
	
	DisposeWindow(gWindow);
	gWindow = nil;
}

pascal OSStatus GameWindowEventHandler(EventHandlerCallRef inHandlerCallRef, EventRef inEvent, void *inUserData)
{
    #pragma unused (inHandlerCallRef)

    OSStatus	err, result = eventNotHandledErr;
	WindowRef	tWindowRef = (WindowRef) inUserData;
	
	switch (GetEventClass(inEvent))
	{
		case kEventClassMouse:
			switch (GetEventKind(inEvent))
			{
				case kEventMouseUp:
					Point	pt;

					err = GetEventParameter(inEvent, kEventParamMouseLocation, typeQDPoint, nil, sizeof(Point), nil, &pt);
					if (err == noErr)
					{
						Rect	rct;
						
						GlobalToLocal(&pt);
						GetWindowBounds(tWindowRef, kWindowContentRgn, &rct);
						if (PtInRect(pt, &rct))
						{				
							if (running)
							{
								if ((Settings.ControllerOption == SNES_JOYPAD) || (Settings.ControllerOption == SNES_MULTIPLAYER5))
								{
									running = false;
									while (s9xthreadrunning)
										sleep(0);
									QuitApplicationEventLoop();
									result = noErr;
								}
							}
							else
							{				
								UInt32	count;
								
								err = GetEventParameter(inEvent, kEventParamClickCount, typeUInt32, nil, sizeof(UInt32), nil, &count);
								if ((err == noErr) && (count == 2))
								{
									SNES9X_Go();
									QuitApplicationEventLoop();
									result = noErr;
								}
							}
						}
					}
			}
	}
	
	return result;
}

void InitRecentItems(void)
{
	CFStringRef	keyRef, pathRef;
	int			count, i;
	char		key[32];
	
	count = 0;
	
	for (i = 0; i <= kRecentMenu_MAX; i++)
		recentItem[i] = nil;
	
	for (i = 0; i <  kRecentMenu_MAX; i++)
	{
		sprintf(key, "RecentItem_%02d", i);
		keyRef = CFStringCreateWithCString(kCFAllocatorDefault, key, CFStringGetSystemEncoding());
		if (keyRef)
		{
			pathRef = (CFStringRef) CFPreferencesCopyAppValue(keyRef, kCFPreferencesCurrentApplication);
			if (pathRef)
			{
				recentItem[count] = pathRef;
				count++;
			}
			
			CFRelease(keyRef);
		}
	}
}

void DeinitRecentItems(void)
{
	CFStringRef	keyRef;
	int			i;
	char		key[32];

	for (i = 0; i < kRecentMenu_MAX; i++)
	{
		sprintf(key, "RecentItem_%02d", i);
		keyRef = CFStringCreateWithCString(kCFAllocatorDefault, key, CFStringGetSystemEncoding());
		if (keyRef)
		{
			if (recentItem[i])
			{
				CFPreferencesSetAppValue(keyRef, recentItem[i], kCFPreferencesCurrentApplication);
				CFRelease(recentItem[i]);
				recentItem[i] = nil;
			}
			else
				CFPreferencesSetAppValue(keyRef, nil, kCFPreferencesCurrentApplication);
			
			CFRelease(keyRef);
		}
	}
	
	CFPreferencesAppSynchronize(kCFPreferencesCurrentApplication);
}

void ClearRecentItems(void)
{
	for (int i = 0; i < kRecentMenu_MAX; i++)
	{
		if (recentItem[i])
		{
			CFRelease(recentItem[i]);
			recentItem[i] = nil;
		}
	}
}

void AddRecentItem(FSRef *ref)
{
	OSStatus	err;
	char		path[PATH_MAX + 1];
	
	err = FSRefMakePath(ref, path, PATH_MAX);
	if (err == noErr)
	{
		CFStringRef	pathRef;
		
		pathRef = CFStringCreateWithCString(kCFAllocatorDefault, path, kCFStringEncodingUTF8);
		if (pathRef)
		{
			int	i, j;
			
			for (i = 0; i < kRecentMenu_MAX; i++)
				if (recentItem[i] && (CFStringCompare(pathRef, recentItem[i], 0) == 0))
					break;
					
			if (i == kRecentMenu_MAX)
			{
				for (j = kRecentMenu_MAX - 1; j >= 0; j--)
					recentItem[j + 1] = recentItem[j];
					
				if (recentItem[kRecentMenu_MAX])
				{
					CFRelease(recentItem[kRecentMenu_MAX]);
					recentItem[kRecentMenu_MAX] = nil;
				}
				
				recentItem[0] = pathRef;
			}
			else
			{
				CFRelease(pathRef);
				
				if (i > 0)
				{
					CFStringRef	temp;
					
					temp = recentItem[i];
				
					for (j = i - 1; j >=0; j--)
						recentItem[j + 1] = recentItem[j];
					
					recentItem[0] = temp;
				}
			}
		}
	}
}

void InitRecentMenu(void)
{
	OSStatus	err;
	
	err = CreateNewMenu(mRecentItem, 0, &recentMenu);
	err = SetMenuItemHierarchicalMenu(GetMenuHandle(mFile), iOpenRecent, recentMenu);
}

void DeinitRecentMenu(void)
{
	ReleaseMenu(recentMenu);
}

void BuildRecentMenu(void)
{
	OSStatus	err;
	CFStringRef	str;
	int			i;
	
	err = DeleteMenuItems(recentMenu, 1, CountMenuItems(recentMenu));
	
	for (i = 0; i < kRecentMenu_MAX; i++)
	{
		if (!recentItem[i])
			break;

		Boolean	r;
		char	path[PATH_MAX + 1];
		
		r = CFStringGetCString(recentItem[i], path, PATH_MAX, kCFStringEncodingUTF8);
		if (r)
		{
			CFStringRef	nameRef;
			char		drive[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], ext[_MAX_EXT];
			
			_splitpath(path, drive, dir, fname, ext);
			strcat(fname, ext);
			nameRef = CFStringCreateWithCString(kCFAllocatorDefault, fname, kCFStringEncodingUTF8);
			if (nameRef)
			{
				err = AppendMenuItemTextWithCFString(recentMenu, nameRef, 0, 'FRe0' + i, nil);
				CFRelease(nameRef);
			}
		}
	}
	
	err = AppendMenuItemTextWithCFString(recentMenu, nil, kMenuItemAttrSeparator, 'FR__', nil);
	
	str = CFCopyLocalizedString(CFSTR("ClearMenu"), "ClearMenu");
	if (str)
	{
		err = AppendMenuItemTextWithCFString(recentMenu, str, 0, 'FRcr', nil);
		CFRelease(str);
	}
}

void S9xGenerateSound(void)
{
	return;
}

pascal void MacProcessSound(SndChannelPtr chan, SndCommand *cmd)
{
	#pragma unused (chan, cmd)
		
	if (so.mute_sound || !Settings.APUEnabled || soundQueued <= 0)
		sndHeader.samplePtr = emptyBuffer;
	else
	{   
		sndHeader.samplePtr = soundBuffer[soundPlayAt];		
		if (++soundPlayAt >= macBufferCount)
			soundPlayAt = 0;
		soundQueued--;
	}
	
	SndCommand buffer   = { bufferCmd, 0, (long) &sndHeader };
	SndDoImmediate(sndChannel, &buffer);

	SndCommand callback = { callBackCmd, 0, 0 };
	SndDoCommand(sndChannel, &callback, true);
}

void InitMacSound(void)
{
	callBackUPP = NewSndCallBackUPP(MacProcessSound);
}

void DeinitMacSound(void)
{
	DisposeSndCallBackUPP(callBackUPP);
}

bool8 S9xOpenSoundDevice(int mode, bool8 stereo, int buffer_size)
{	
	#pragma unused (mode, stereo)
	
	int	count;
	
	if (sndChannel)
	{
		SndDisposeChannel(sndChannel, true);
		sndChannel = nil;
	}

	so.playback_rate = Settings.SoundPlaybackRate;
    so.stereo        = Settings.Stereo;
    so.sixteen_bit   = Settings.SixteenBitSound;
    so.encoded       = false;

	macSoundPitchMaster = macSoundPitch;
	
	so.buffer_size = buffer_size;
	if (so.sixteen_bit)
		so.buffer_size <<= 1;
	if (so.stereo)
		so.buffer_size <<= 1;

  	memset(&sndHeader, 0, sizeof(sndHeader));
	sndHeader.numChannels   = so.stereo ? 2 : 1;
	sndHeader.sampleRate    = so.playback_rate << 16;
	sndHeader.encode        = extSH;
	sndHeader.baseFrequency = kMiddleC;
	sndHeader.numFrames     = buffer_size;
	sndHeader.sampleSize    = so.sixteen_bit ? 16 : 8;
  
	if (soundBufferAt != -1)
	{
		for (count = 0; count < kMaxSoundBuffers; count++)
			free(soundBuffer[count]);
		free(emptyBuffer);
	}
	
	for (count = 0; count < kMaxSoundBuffers; count++)
		soundBuffer[count] = (char *) calloc(so.buffer_size, 1);
	emptyBuffer = (char *) calloc(so.buffer_size, 1);
	
	soundBufferAt = soundPlayAt = soundQueued = 0;
	
    SndNewChannel(&sndChannel, sampledSynth, so.stereo ? initStereo : initMono, callBackUPP);
	
	SndCommand	sndcmd;
	UInt32		volume;
	
	volume = (UInt32) (256.0 * (float) macSoundVolume / 100.0);
	
	sndcmd.cmd = volumeCmd;
    sndcmd.param1 = 0;
    sndcmd.param2 = (volume << 16) | volume;
    SndDoCommand(sndChannel, &sndcmd, true);
	
	sndcmd.cmd = callBackCmd;
    sndcmd.param1 = 0;
    sndcmd.param2 = 0;	
	SndDoCommand(sndChannel, &sndcmd, true);
	
	return true;
}

void InitAutoFire(void)
{
	autofire = false;
	
	for (int i = 0; i < 2; i++)
	{
		autofireRec[i].nextTime   = 0;
		autofireRec[i].keyboard   = 0;
		autofireRec[i].joypad     = 0;
		autofireRec[i].buttonMask = 0;
		autofireRec[i].frequency  = 10;
	}
}

void InitMP(void)
{		
	if (MPLibraryIsLoaded())
	{
		if (MPProcessorsScheduled() > 1)
			multiprocessor = true;
	}
}

OSStatus BlitMPTask(void *parameter)
{
	OSStatus	err = noErr;
    long		theCommand, param1, param2;

	#pragma unused (parameter)
	
	printf("MP: Entered DirectDraw thread.\n");
    
	for (;;)
    {
		err = MPWaitOnQueue(taskQueue, (void **) &theCommand, (void **) &param1, (void **) &param2, kDurationForever);
        if (err)
			break;
               
		if (theCommand == kMPBlitFrame)
		{
			(mpDataBuffer->blitFn) (mpDataBuffer->gfxBuffer, mpDataBuffer->dstPtr, mpDataBuffer->dstRowBytes, &mpDataBuffer->srcRect, &mpDataBuffer->copyRect);
 			MPSignalSemaphore(readySemaphore);
		}
		else
		if (theCommand == kMPBlitDone)
			break;
		else
		{
			err = userCanceledErr;
			break;
		}
	}

	MPFree(mpDataBuffer);
	MPDeleteSemaphore(readySemaphore);
    MPDeleteQueue(taskQueue);
	mpDataBuffer = nil;
	readySemaphore = nil;
	taskQueue = nil;
	
	printf("MP: Exited DirectDraw thread.\n");

	return err;
}

OSStatus BlitMPGLTask(void *parameter)
{
	OSStatus	err = noErr;
    long		theCommand, param1, param2;

	#pragma unused (parameter)
	
	printf("MP: Entered BlitGL thread.\n");
    
	for (;;)
    {
		err = MPWaitOnQueue(taskQueue, (void **) &theCommand, (void **) &param1, (void **) &param2, kDurationForever);
        if (err)
			break;
               
		if (theCommand == kMPBlitFrame)
		{
			(mpDataBuffer->blitFn) (mpDataBuffer->gfxBuffer, mpDataBuffer->dstPtr, mpDataBuffer->dstRowBytes, &mpDataBuffer->srcRect, &mpDataBuffer->copyRect);
 			S9xPutImageBlitGL2(mpDataBuffer->copyRect.bottom);
			MPSignalSemaphore(readySemaphore);
		}
		else
		if (theCommand == kMPBlitDone)
			break;
		else
		{
			err = userCanceledErr;
			break;
		}
	}

	MPFree(mpDataBuffer);
	MPDeleteSemaphore(readySemaphore);
    MPDeleteQueue(taskQueue);
	mpDataBuffer = nil;
	readySemaphore = nil;
	taskQueue = nil;
	
	printf("MP: Exited BlitGL thread.\n");

	return err;
}

OSStatus PrepareMPBlit(void)
{
	OSStatus	err;
	
	mpDataBuffer = (MPData *) MPAllocateAligned(sizeof(MPData), kMPAllocateDefaultAligned, kMPAllocateClearMask);
	if (!mpDataBuffer)
		return memFullErr;
	
	err = MPCreateQueue(&notificationQueue);
	if (err == noErr)
	{
		err = MPCreateQueue(&taskQueue);
		if (err == noErr)
		{
			err = MPCreateBinarySemaphore(&readySemaphore);
			if (err == noErr)
			{
				MPSignalSemaphore(readySemaphore);
				err = MPCreateTask(BlitMPTask, nil, 0, notificationQueue, nil, nil, 0, &taskID);
			}
		}
	}

	return err;
}

OSStatus PrepareMPBlitGL(void)
{
	OSStatus	err;
	
	mpDataBuffer = (MPData *) MPAllocateAligned(sizeof(MPData), kMPAllocateDefaultAligned, kMPAllocateClearMask);
	if (!mpDataBuffer)
		return memFullErr;
	
	err = MPCreateQueue(&notificationQueue);
	if (err == noErr)
	{
		err = MPCreateQueue(&taskQueue);
		if (err == noErr)
		{
			err = MPCreateBinarySemaphore(&readySemaphore);
			if (err == noErr)
			{
				MPSignalSemaphore(readySemaphore);
				err = MPCreateTask(BlitMPGLTask, nil, 0, notificationQueue, nil, nil, 0, &taskID);
			}
		}
	}

	return err;
}

OSErr ExportPicHandleToFile(PicHandle thePicture, OSType filetype, OSType filecreator, FSSpec *filespec, ScriptCode filescriptcode)
{
    OSErr					err;
	Handle					hdl;
    GraphicsImportComponent gic;
	
	#define	kMaxQuality	1024
    
    hdl = NewHandleClear(512);
	err = MemError();
	if (!err)
	{
		err = HandAndHand((Handle) thePicture, hdl);
		if (!err)
		{
			err = OpenADefaultComponent(GraphicsImporterComponentType, kQTFileTypePicture, &gic);
			if (!err)
			{
				err = GraphicsImportSetQuality(gic, kMaxQuality);
				if (!err)
				{
					err = GraphicsImportSetDataHandle(gic, hdl);
					if (!err)
						err = GraphicsImportExportImageFile(gic, filetype, filecreator, filespec, filescriptcode);
				}
				
				CloseComponent(gic);
			}
		}
		
		DisposeHandle(hdl);
	}
	
    return err;
}

PicHandle GetScreenAsPicHandle(int width, int height, int destWidth, int destHeight)
{
	PicHandle	myPicture;
	Rect		drawSize, scaleSize;
	GWorldPtr	drawWorld, scaleWorld;
	Byte		*graphicsIn, *graphicsOut; 
	int			row, graphicsRowBytes;

	SetRect(&drawSize,  0, 0, width,     height);
	SetRect(&scaleSize, 0, 0, destWidth, destHeight);
	
	InitGWorld(&drawWorld,  &drawSize,  16);
	InitGWorld(&scaleWorld, &scaleSize, 16);

	graphicsIn  = (Byte *) GFX.Screen;
	graphicsOut = (Byte *) GetPixBaseAddr(GetGWorldPixMap(drawWorld));
	graphicsRowBytes = GetPixRowBytes(GetGWorldPixMap(drawWorld));
	
	for (row = 0; row < height; row++)
	{
		memcpy(graphicsOut, graphicsIn, width * 2);
		
		if (directDisplay)
		{
			if (drawingMethod == kDrawingDirect)
				graphicsIn += 512 * 2;
			else
				graphicsIn += width * 2;
		}
		else
		{
			if (lastDrawingMethod == kDrawingDirect)
				graphicsIn += 512 * 2;
			else
				graphicsIn += width * 2;
		}
		
		graphicsOut += graphicsRowBytes;
	}

	if ((scaleSize.right * scaleSize.bottom) < (drawSize.right * drawSize.bottom))
	{
		PrepareForGDrawing(drawWorld);
		CopyBits(GetPortBitMapForCopyBits(drawWorld),  GetPortBitMapForCopyBits(scaleWorld), &drawSize,  &scaleSize, srcCopy | ditherCopy, nil);
		FinishGDrawing(drawWorld);

		PrepareForGDrawing(scaleWorld);
		myPicture = OpenPicture(&scaleSize);
		CopyBits(GetPortBitMapForCopyBits(scaleWorld), GetPortBitMapForCopyBits(scaleWorld), &scaleSize, &scaleSize, srcCopy, nil);
		ClosePicture();
		FinishGDrawing(scaleWorld);
	}
	else
	{
		PrepareForGDrawing(scaleWorld);
		myPicture = OpenPicture(&scaleSize);
		CopyBits(GetPortBitMapForCopyBits(drawWorld),  GetPortBitMapForCopyBits(scaleWorld), &drawSize,  &scaleSize, srcCopy, nil);
		ClosePicture();
		FinishGDrawing(scaleWorld);
	}

	DisposeGWorld(drawWorld);
	DisposeGWorld(scaleWorld);

	return myPicture;
}

void WriteScreenAsPICTResource(FSSpec *file, int destWidth, int destHeight)
{
	short		refNum;
	PicHandle	myPicture;
	
	myPicture = GetScreenAsPicHandle(imageWidth, imageHeight, destWidth, destHeight);
	
	refNum = FSpOpenResFile(file, fsWrPerm);
	AddResource((Handle) myPicture, 'PICT', 128, "\p");
	WriteResource((Handle) myPicture);

	ReleaseResource((Handle) myPicture);
	CloseResFile(refNum);
}

void QuickScreenshot(int width, int height)
{	
	OSErr		err;
	PicHandle	myPicture;
	FSRef		ref;
	FSSpec		spec;
	FILE		*fs;
	const char	*filename;
	
	myPicture = GetScreenAsPicHandle(width, height, width * ((width <= 256) ? 2 : 1), height * ((height <= 239) ? 2 : 1));
	
	filename = S9xGetPNGFilename();
	fs = fopen(filename, "wb");
	if (fs)
	{
		fclose(fs);
	
		err = FSPathMakeRef(filename, &ref, nil);
		err = FSGetCatalogInfo(&ref, kFSCatInfoNone, nil, nil, &spec, nil);
		err = ExportPicHandleToFile(myPicture, kQTFileTypePNG, 0, &spec, smSystemScript);
	}

	KillPicture(myPicture);	
}

void DrawPauseScreen(void)
{
	PicHandle			pict;
	QDPictRef			pref;
	CGrafPtr			port;
	CGDataProviderRef	prov;
	CGContextRef		ctx;
	CGRect				crt;
	Rect				copyRect;
	long				size;
	short				width, height;

	if (!gWindow)
		return;
	
	width = imageWidth;
	height = imageHeight;
	copyRect.top = copyRect.left = 0;
	
	if ((width == 0) || (height == 0))
		return;
	
	if (width > 256)
	{
		copyRect.right  = width;
		
		if (height > 240)
		{
			copyRect.bottom = height;
			
			if (height <= 448)
			{
				copyRect.top     = 16;
				copyRect.bottom += 16;
			}
		}
		else
		{			
			copyRect.bottom = height * 2;
			
			if (height <= 224)
			{
				copyRect.top     = 16;
				copyRect.bottom += 16;
			}
			else
			if (height == 239)
			{
				copyRect.top     = 1;
				copyRect.bottom += 1;
			}
		}
	}
	else
	{
		if (doubleSize)
		{
			copyRect.right =   width * 2;
			copyRect.bottom = height * 2;
			
			if (height <= 224)
			{
				copyRect.top     = 16;
				copyRect.bottom += 16;
			}
			else
			if (height == 239)
			{
				copyRect.top     = 1;
				copyRect.bottom += 1;
			}
		}
		else
		{
			copyRect.top    = 120;
			copyRect.left   = 128;
			copyRect.bottom = 120 + height;
			copyRect.right  = 128 + width;
			
			if (height <= 224)
			{
				copyRect.top    += 8;
				copyRect.bottom += 8;
			}				
		}
	}
	
	pict = GetScreenAsPicHandle(imageWidth, imageHeight, copyRect.right - copyRect.left, copyRect.bottom - copyRect.top);
	if (pict == nil)
		return;
	
	HLock((Handle) pict);
	
	size = GetHandleSize((Handle) pict);
	prov = CGDataProviderCreateWithData(nil, (void *) *pict, size, nil);
	if (prov)
	{
		pref = QDPictCreateWithProvider(prov);
		if (pref)
		{
			port = GetWindowPort(gWindow);
			if (!CreateCGContextForPort(port, &ctx))
			{
				CGContextSetLineWidth(ctx, 0);
				
				crt = CGRectMake(0.0, 0.0, 512.0, 480.0);
				CGContextSetRGBFillColor(ctx, 0.0, 0.0, 0.0, 1.0);
				CGContextBeginPath(ctx);
				CGContextAddRect(ctx, crt);	
				CGContextClosePath(ctx);
				CGContextFillPath(ctx);
	
				crt = CGRectOffset(QDPictGetBounds(pref), (float) copyRect.left, (float) copyRect.top);
				QDPictDrawToCGContext(ctx, crt, pref);
				
				CGContextSetRGBFillColor(ctx, 0.0, 0.0, 0.0, 0.5);
				CGContextBeginPath(ctx);
				CGContextAddRect(ctx, crt);	
				CGContextClosePath(ctx);
				CGContextFillPath(ctx);
	
				CGContextFlush(ctx);
				
				CGContextRelease(ctx);
			}
			
			QDPictRelease(pref);
		}
		
		CGDataProviderRelease(prov);
	}
	
	HUnlock((Handle) pict);
	
	KillPicture(pict);
}

void DisableMenus(void)
{
	DisableMenuItem(GetMenuHandle(mApple),     iAbout);
	DisableMenuItem(GetMenuHandle(mFile),      0);
	DisableMenuItem(GetMenuHandle(mEmulation), 0);
	DisableMenuItem(GetMenuHandle(mControl),   0);
	DisableMenuItem(GetMenuHandle(mCheat),     0);
	DisableMenuItem(GetMenuHandle(mOption),    0);
	DisableMenuCommand(nil, kHICommandPreferences);
	DisableMenuCommand(nil, kHICommandQuit);
	
	DrawMenuBar();
}

void EnableMenus(void)
{
	EnableMenuItem(GetMenuHandle(mApple),     iAbout);
	EnableMenuItem(GetMenuHandle(mFile),      0);
	EnableMenuItem(GetMenuHandle(mEmulation), 0);
	EnableMenuItem(GetMenuHandle(mControl),   0);
	EnableMenuItem(GetMenuHandle(mCheat),     0);
	EnableMenuItem(GetMenuHandle(mOption),    0);
	EnableMenuCommand(nil, kHICommandPreferences);
	EnableMenuCommand(nil, kHICommandQuit);
	
	PrepareMenus();
	DrawMenuBar();
}

OSStatus HandleMenuChoice(long command, Boolean *done)
{
	OSStatus	err, result = noErr;
	MenuRef		mh;
	int			item;
	
	if ((command & 0xFFFFFF00) == 'FRe\0')
	{
		Boolean	r;
		int		index;
		char	path[PATH_MAX + 1];
		
		index = (int) (command & 0x000000FF) - (int) '0';
		r = CFStringGetCString(recentItem[index], path, PATH_MAX, kCFStringEncodingUTF8);
		if (r)
		{
			FSRef	ref;
			
			err = FSPathMakeRef(path, &ref, nil);
			if (err == noErr)
			{
				if (SNES9X_OpenCart(&ref))
				{
					SNES9X_Go();
					*done = true;
				}
			}
		}
	}
	else
	{
		switch (command)
		{
			case 'abou':	// About SNES9X
				StartCarbonModalDialog();
				AboutDialog();
				FinishCarbonModalDialog();
	
				break;
				
			case 'pref':	// Preferences...
				StartCarbonModalDialog();
				ConfigurePreferences();
				FinishCarbonModalDialog();
			
				break;
				
			case 'quit':	// Quit SNES9X
				SNES9X_Quit();
				*done = true;
				
				break;
			
			case 'open':	// Open ROM Image...
				if (SNES9X_OpenCart(nil))
				{
					SNES9X_Go();
					*done = true;
				}
				
				break;
				
			case 'FRcr':	// Clear Menu
				ClearRecentItems();
				BuildRecentMenu();
				
				break;
				
			case 'Finf':	// ROM Information
				StartCarbonModalDialog();
				RomInfoDialog();
				FinishCarbonModalDialog();
					
				break;
				
			case 'Ckey':	// Configure Keyboard...
				StartCarbonModalDialog();
				ConfigureKeyboard();
				FinishCarbonModalDialog();
					
				break;
					
			case 'Cpad':	// Configure Controllers...
				StartCarbonModalDialog();	
				ConfigureHID();
				FinishCarbonModalDialog();
						
				break;
						
			case 'Caut':	// Automatic Fire...
				StartCarbonModalDialog();	
				ConfigureAutoFire();
				FinishCarbonModalDialog();
	
				break;
	
			case 'Hapl':	// Apply Cheat Entries
				mh = GetMenuHandle(mCheat);
				applycheat = !applycheat;
				CheckMenuItem(mh, iApplyCheats, applycheat);
				Settings.ApplyCheats = applycheat;
						
				if (!Settings.ApplyCheats)
					S9xRemoveCheats();
				else
					S9xApplyCheats();
	
				break;
			
			case 'Hent':	// Cheat Entry...
				StartCarbonModalDialog();	
				ConfigureCheat();
				FinishCarbonModalDialog();
						
				break;
	
			case 'Hfnd':	// Cheat Finder...
				StartCarbonModalDialog();	
				CheatFinder();
				FinishCarbonModalDialog();
						
				break;

			case 'Erun':	// Run
				SNES9X_Go();
				*done = true;
						
				break;
			
			case 'Esrs':	// Software Reset
				SNES9X_SoftReset();
				//printf("\nSoft Reset.\n\n");
				SNES9X_Go();
				*done = true;
						
				break;

			case 'Erst':	// Hardware Reset
				SNES9X_Reset();
				//printf("\nHard Reset.\n\n");
				SNES9X_Go();
				*done = true;
						
				break;
														
			case 'Eswp':	// Swap Pads
				mh = GetMenuHandle(mEmulation);
				Settings.SwapJoypads = !Settings.SwapJoypads;
				CheckMenuItem(mh, iSwapPad, Settings.SwapJoypads);

				break;
				
			case 'Essc':	// Hide or Show Gunsight Cursor
				CFStringRef	ref;
				
				scopecursor = !scopecursor;
	
				if (scopecursor)
					ref = CFCopyLocalizedString(CFSTR("HideScopeCursor"), "hide");
				else
					ref = CFCopyLocalizedString(CFSTR("ShowScopeCursor"), "show");
				mh = GetMenuHandle(mEmulation);
				err = SetMenuItemTextWithCFString(mh, iScopeCursor, ref);
				CFRelease(ref);
				
				break;
						
			case 'Ofrz':	// Freeze State
				SNES9X_Freeze();
				*done = true;
						
				break;
					
			case 'Odfr':	// Defrost state
				SNES9X_Defrost();
				*done = true;
						
				break;
						
			case 'Ofrd':	// Freeze State to...
				StartCarbonModalDialog();
				SNES9X_FreezeTo();
				FinishCarbonModalDialog();
				
				break;
			
			case 'Odfd':	// Defrost State From...
				StartCarbonModalDialog();
				SNES9X_DefrostFrom();
				if (gWindow)
					ActivateWindow(gWindow, true);
				FinishCarbonModalDialog();
				*done = true;
				
				break;
	
			case 'Ospc':	// Save SPC File at Next Note-on
				spc_is_dumping = 1;
						
				break;
						
			case 'Osrm':	// Save SRAM Now
				SNES9X_SaveSRAM();
						
				break;
				
			case 'Ombx':	// Music Box
				StartCarbonModalDialog();
				MusicBoxDialog();
				FinishCarbonModalDialog();
	
				break;
				
			case 'CPr1':	// Controller Preset
			case 'CPr2':
			case 'CPr3':
			case 'CPr4':
			case 'CPr5':		
				item = (int) (command & 0x000000FF) - (int) '0';
				err = GetMenuItemHierarchicalMenu(GetMenuHandle(mControl), iISpPreset, &mh);
				CheckMenuItem(mh, padSetting, false);
				padSetting = item;
				CheckMenuItem(mh, padSetting, true);
				ClearPadSetting();
				Load_Config();
				
				break;
				
			case 'EIp1':	// Input Device
			case 'EIp2':
			case 'EIp3':
			case 'EIp4':
			case 'EIp5':
			case 'EIp6':
			case 'EIp7':
				item = (int) (command & 0x000000FF) - (int) '0';
				err = GetMenuItemHierarchicalMenu(GetMenuHandle(mEmulation), iDevice, &mh);
				CheckMenuItem(mh, deviceSetting, false);
				deviceSetting = item;
				CheckMenuItem(mh, deviceSetting, true);
				ChangeInputDevice();
				
				break;
				
			default:
				result = eventNotHandledErr;
		}
	}
	
	return result;
}

void PrepareMenus(void)
{
	MenuHandle	fileMenu, emuMenu, ctrlMenu, cheatMenu, optionMenu;

	fileMenu   = GetMenuHandle(mFile);
	emuMenu    = GetMenuHandle(mEmulation);
	ctrlMenu   = GetMenuHandle(mControl);
	cheatMenu  = GetMenuHandle(mCheat);
	optionMenu = GetMenuHandle(mOption);

	if (cartOpen)
	{
		EnableMenuItem(fileMenu,   iRomInfo);
		EnableMenuItem(emuMenu,    iResume);
		EnableMenuItem(emuMenu,    iSoftReset);
		EnableMenuItem(emuMenu,    iReset);
		EnableMenuItem(cheatMenu,  0);
		EnableMenuItem(optionMenu, 0);
	}
	else
	{
		DisableMenuItem(fileMenu,   iRomInfo);
		DisableMenuItem(emuMenu,    iResume);
		DisableMenuItem(emuMenu,    iSoftReset);
		DisableMenuItem(emuMenu,    iReset);		
		DisableMenuItem(cheatMenu,  0);
		DisableMenuItem(optionMenu, 0);
	}
	
	if (hidExist)
	{
		EnableMenuItem(ctrlMenu, iISpLayout);
		EnableMenuItem(ctrlMenu, iISpPreset);
	}
	else
	{
		DisableMenuItem(ctrlMenu, iISpLayout);
		DisableMenuItem(ctrlMenu, iISpPreset);
	}
}

Ptr SaveGWorldPixMap(GWorldPtr myWorld)
{
	PixMapHandle	GWorldPixMap;
	Ptr 			originalVideo;
	unsigned long	numRows, pixMapSize;
	bool			pixLocked;
	
	pixLocked = (GetPixelsState(GetGWorldPixMap(myWorld)) == pixelsLocked ? 1 : 0);
	
	LockPixels(GetGWorldPixMap(myWorld));
	
	GWorldPixMap = GetGWorldPixMap(myWorld);
	numRows = (*GWorldPixMap)->bounds.bottom - (*GWorldPixMap)->bounds.top;
	pixMapSize = GetPixRowBytes(GWorldPixMap) * numRows;
	originalVideo = NewPtr(pixMapSize);
	
	BlockMove(GetPixBaseAddr(GWorldPixMap), originalVideo, pixMapSize);
	
	if (!pixLocked)
		UnlockPixels(GetGWorldPixMap(myWorld));
	
	return originalVideo;
}

void RestoreGWorldPixMap(GWorldPtr myWorld, Ptr originalVideo)
{
	PixMapHandle	GWorldPixMap;
	unsigned long	numRows, pixMapSize;
	bool			pixLocked;
	
	pixLocked = (GetPixelsState(GetGWorldPixMap(myWorld)) == pixelsLocked ? 1 : 0);
	
	LockPixels(GetGWorldPixMap(myWorld));
	
	GWorldPixMap = GetGWorldPixMap(myWorld);
	numRows = (*GWorldPixMap)->bounds.bottom - (*GWorldPixMap)->bounds.top;
	pixMapSize = GetPixRowBytes(GWorldPixMap) * numRows;
	
	BlockMove(originalVideo, GetPixBaseAddr(GWorldPixMap), pixMapSize);
		
	if (!pixLocked)
		UnlockPixels(GetGWorldPixMap(myWorld));
}

void UpdateActiveFrame(int newIndex, GWorldPtr myWorld, Ptr originalVideo)
{
	uint8	*videoOut, *videoIn;
	uint8	swapBuffer[512 * 2];
	int		saveImageWidth, saveImageHeight, saveImageDepth, lineCopySize, lineInSize, count;
	bool	pixLocked;
				
	pixLocked = GetPixelsState(GetGWorldPixMap(myWorld)) == pixelsLocked ? 1 : 0;

	LockPixels(GetGWorldPixMap(myWorld));

	if (newIndex >= 0 && newIndex < 12)
	{
		RGBColor	yellowColor = { 0xFFFF, 0xFFFF, 0x0000 };
		Rect		drawRect    = { 120, 0, 240, 128 };

		OffsetRect(&drawRect, 128 * (newIndex % 4), 120 * (newIndex / 4));
		drawRect.bottom--;
		drawRect.right--;
		RGBForeColor(&yellowColor);
		FrameRect(&drawRect);
		InsetRect(&drawRect, 1, 1 );
		ForeColor(blackColor);
		FrameRect(&drawRect);
	}
		
	lineCopySize = 512 * (Settings.SixteenBit ? 2 : 1),
	lineInSize   = GetPixRowBytes(GetGWorldPixMap(myWorld));

	saveImageWidth  = imageWidth;
	saveImageHeight = imageHeight;
	saveImageDepth  = imageDepth;
	
	videoOut = GFX.Screen;
	videoIn  = (uint8 *) GetPixBaseAddr(GetGWorldPixMap(myWorld));
	for (count = 0; count < 480; count++)
	{
		memcpy(swapBuffer, videoOut,   lineCopySize);
		memcpy(videoOut,   videoIn,    lineCopySize);
		memcpy(videoIn,	   swapBuffer, lineCopySize);
		videoOut += 512 * 2;
		videoIn  += lineInSize;
	}

	S9xPutImage(512, 480, Settings.SixteenBit);
	
	imageWidth  = saveImageWidth;
	imageHeight = saveImageHeight;
	imageDepth  = saveImageDepth;
	
	videoOut = GFX.Screen;
	videoIn  = (uint8 *) GetPixBaseAddr(GetGWorldPixMap(myWorld));
	for (count = 0; count < 480; count++)
	{
		memcpy(videoOut, videoIn, lineCopySize);
		videoOut += 512 * 2;
		videoIn  += lineInSize;
	}
	
	RestoreGWorldPixMap(myWorld, originalVideo);

	if (!pixLocked)
		UnlockPixels(GetGWorldPixMap(myWorld));
}

int PromptFreezeDefrost(Boolean freezing)
{
	OSStatus		err;
	GWorldPtr		myWorld;
	Ptr				originalVideo;
	PicHandle		myPict;
	SndListHandle	clickSound;
	KeyMap			myKeys;
	FSCatalogInfo	info;
	FSRef			ref;
	FSSpec			spec;
	UInt64			newestDate, currentDate;
	unsigned long	startTime;
	unsigned int	repeatDelay;
	long			newestIndex;
	short			current_selection, refNum;
	int				count, result;
	const char		*filename;

	Rect 			drawRect   = { 120, 0, 240, 128 };
	Rect			worldRect  = {   0, 0, 480, 512 };
	Rect			headerRect = {   0, 0, 120, 512 };
	RGBColor		darkGray   = { 0x4000, 0x4000, 0x4000 };
	char			letters[]  = "123456789ABC";
	uint8			keyCheck[] = { kmEscKey, km1Key, km2Key, km3Key, km4Key, km5Key,
								   km6Key,	 km7Key, km8Key, km9Key, kmAKey, kmBKey, kmCKey };

	if (!directDisplay) 
	{
		S9xInitDisplay(nil, nil);
		SNES9X_Go();
	}
	
	S9xSetSoundMute(true);

	InitGWorld(&myWorld, &worldRect, Settings.SixteenBit ? 16 : 8);
	PrepareForGDrawing(myWorld);

	TextFont(kFontIDGeneva);
	TextSize(9);
	ForeColor(blackColor);
	PaintRect(&worldRect);

	myPict = GetPicture(freezing ? 129 : 130);	
	if (myPict)
	{
		DrawPicture(myPict, &headerRect);
		ReleaseResource((Handle) myPict);
	}
	
	newestDate  = 0;
	newestIndex = -1;

	for (count = 0; count < 12; count++)
	{
		filename = S9xGetFreezeFilename(count);
		err = FSPathMakeRef(filename, &ref, nil);
		if (err == noErr)
		{
			err = FSGetCatalogInfo(&ref, kFSCatInfoContentMod, &info, nil, &spec, nil);
			currentDate = (((UInt64) info.contentModDate.highSeconds << 48) | ((UInt64) info.contentModDate.lowSeconds << 16) | (UInt64) info.contentModDate.fraction);
			
			if (currentDate > newestDate)
			{
				newestIndex = count;
				newestDate  = currentDate;
			}
			
			refNum = FSpOpenResFile(&spec, fsRdPerm);
			err = ResError();
			myPict = GetPicture(128);			
			if (myPict)
			{
				DrawPicture(myPict, &drawRect); 
				ReleaseResource((Handle) myPict);
			}
			if (err == noErr)
				CloseResFile(refNum);

			ForeColor(blackColor);
			MoveTo(drawRect.right - 1, drawRect.top);
			Line(0, 119);
			Line(-127, 0);

			MoveTo(drawRect.left + 5, drawRect.top + 15);
			TextFace(bold | outline);
			ForeColor(blackColor);
			DrawChar(letters[count]);
			MoveTo(drawRect.left + 5, drawRect.top + 15);
			TextFace(bold);
			ForeColor(whiteColor);
			DrawChar(letters[count]);
			
			if (showtimeinfrz)
			{
				LocalDateTime	localtime;
				LongDateTime	ldtime;
				Str255			p1, p2, datetimestr;

				ConvertUTCToLocalDateTime(&(info.contentModDate), &localtime);					
				ldtime = (LongDateTime) ((((UInt64) localtime.highSeconds) << 32) | ((UInt64) localtime.lowSeconds));
				LongDateString(&ldtime, shortDate, p1, nil);		
				LongTimeString(&ldtime, true, p2, nil);
				JointPStrings(p1, "\p  ", p2, datetimestr);
				
				MoveTo(drawRect.left + 22, drawRect.top + 15);
				TextFace(condense | outline);
				ForeColor(blackColor);
				DrawString(datetimestr);
				MoveTo(drawRect.left + 22, drawRect.top + 15);
				TextFace(0);
				ForeColor(whiteColor);
				DrawString(datetimestr);
			}
		}
		else
		{
			MoveTo(drawRect.left + 5, drawRect.top + 15);
			TextFace(bold);
			RGBForeColor(&darkGray);
			DrawChar(letters[count]);
		}
		
		if ((count % 4) == 3)
			OffsetRect(&drawRect, -128 * 3, 120);
		else
			OffsetRect(&drawRect, 128, 0);
	}
	
	if (newestIndex < 0)
		newestIndex = 0;
	
	originalVideo = SaveGWorldPixMap(myWorld);
	UpdateActiveFrame(newestIndex, myWorld, originalVideo);

	clickSound = (SndListHandle) GetResource('snd ', 128);
	if (clickSound)
	{
		SndPlay(nil, clickSound, false);
		ReleaseResource((Handle) clickSound);
	}
	
	result = -2;
	repeatDelay = 20;
	current_selection = (newestIndex == -1 ? 0 : newestIndex);

	do
	{
		GetKeys(myKeys);
		for (count = 0; count <= 12; count++)
		{
			while (KeyIsPressed(myKeys, keyCheck[count]))
			{
				result = count - 1;
				GetKeys(myKeys);
			}	
		}
		
		while (KeyIsPressed(myKeys, keyCode[k1PRight]))
		{
			startTime = TickCount();
			current_selection += 1;
			if (current_selection > 11)
				current_selection -= 12;
			UpdateActiveFrame(current_selection, myWorld, originalVideo);
			while (KeyIsPressed(myKeys, keyCode[k1PRight]) && (TickCount() < (startTime + repeatDelay)))
				GetKeys(myKeys);
		}

		while (KeyIsPressed(myKeys, keyCode[k1PLeft]))
		{
			startTime = TickCount();
			current_selection -= 1;
			if (current_selection < 0)
				current_selection += 12;
			UpdateActiveFrame(current_selection, myWorld, originalVideo);
			while (KeyIsPressed(myKeys, keyCode[k1PLeft]) && (TickCount() < (startTime + repeatDelay)))
				GetKeys(myKeys);
		}
		
		while (KeyIsPressed(myKeys, keyCode[k1PDown]))
		{
			startTime = TickCount();
			current_selection += 4;
			if (current_selection > 11)
				current_selection -= 12;
			UpdateActiveFrame(current_selection, myWorld, originalVideo);
			while (KeyIsPressed(myKeys, keyCode[k1PDown]) && (TickCount() < (startTime + repeatDelay)))
				GetKeys(myKeys);
		}
		
		while (KeyIsPressed(myKeys, keyCode[k1PUp]))
		{
			startTime = TickCount();
			current_selection -= 4;
			if (current_selection < 0)
				current_selection += 12;
			UpdateActiveFrame(current_selection, myWorld, originalVideo);
			while (KeyIsPressed(myKeys, keyCode[k1PUp]) && (TickCount() < (startTime + repeatDelay)))
				GetKeys(myKeys);
		}

		while (KeyIsPressed(myKeys, keyCode[k1PA]     ) ||
			   KeyIsPressed(myKeys, keyCode[k2PA]     ) ||
			   KeyIsPressed(myKeys, keyCode[k1PB]     ) ||
			   KeyIsPressed(myKeys, keyCode[k2PB]     ) ||
			   KeyIsPressed(myKeys, keyCode[k1PX]     ) ||
			   KeyIsPressed(myKeys, keyCode[k2PX]     ) ||
			   KeyIsPressed(myKeys, keyCode[k1PY]     ) ||
			   KeyIsPressed(myKeys, keyCode[k2PY]     ) ||
			   KeyIsPressed(myKeys, keyCode[k1PStart] ) ||
			   KeyIsPressed(myKeys, keyCode[k1PSelect]) ||
			   KeyIsPressed(myKeys, keyCode[k2PStart] ) ||
			   KeyIsPressed(myKeys, keyCode[k2PSelect]))
		{
			GetKeys(myKeys);
			result = current_selection;
		}
		
		uint32	pad1 = 0, pad2 = 0;
		
		while (ISpKeyIsPressed(kISpEsc    ) ||
			   ISpKeyIsPressed(kISp1PStart) ||
			   ISpKeyIsPressed(kISp2PStart))
			result = -1;
		
		pad1 = pad2 = 0;
		JoypadScanDirection(0, &pad1);
		JoypadScanDirection(1, &pad2);
		while ((pad1 & 0x0100) || (pad2 & 0x0100))	// Rt
		{
			startTime = TickCount();
			current_selection += 1;
			if (current_selection > 11)
				current_selection -= 12;
			UpdateActiveFrame(current_selection, myWorld, originalVideo);
			do
			{
				pad1 = pad2 = 0;
				JoypadScanDirection(0, &pad1);
				JoypadScanDirection(1, &pad2);
			}	
			while (((pad1 & 0x0100) || (pad2 & 0x0100)) && (TickCount() < (startTime + repeatDelay)));
		}
		
		pad1 = pad2 = 0;
		JoypadScanDirection(0, &pad1);
		JoypadScanDirection(1, &pad2);
		while ((pad1 & 0x0200) || (pad2 & 0x0200))	// Lf
		{
			startTime = TickCount();
			current_selection -= 1;
			if (current_selection < 0) 
				current_selection += 12;
			UpdateActiveFrame(current_selection, myWorld, originalVideo);
			do
			{
				pad1 = pad2 = 0;
				JoypadScanDirection(0, &pad1);
				JoypadScanDirection(1, &pad2);
			}	
			while (((pad1 & 0x0200) || (pad2 & 0x0200)) && (TickCount() < (startTime + repeatDelay)));
		}
		
		pad1 = pad2 = 0;
		JoypadScanDirection(0, &pad1);
		JoypadScanDirection(1, &pad2);
		while ((pad1 & 0x0800) || (pad2 & 0x0800))	// Up
		{
			startTime = TickCount();
			current_selection -= 4;
			if (current_selection < 0) 
				current_selection += 12;
			UpdateActiveFrame(current_selection, myWorld, originalVideo);
			do
			{
				pad1 = pad2 = 0;
				JoypadScanDirection(0, &pad1);
				JoypadScanDirection(1, &pad2);
			}	
			while (((pad1 & 0x0800) || (pad2 & 0x0800)) && (TickCount() < (startTime + repeatDelay)));
		}
			
		pad1 = pad2 = 0;
		JoypadScanDirection(0, &pad1);
		JoypadScanDirection(1, &pad2);
		while ((pad1 & 0x0400) || (pad2 & 0x0400))	// Dn
		{
			startTime = TickCount();
			current_selection += 4;
			if (current_selection > 11)
				current_selection -= 12;
			UpdateActiveFrame(current_selection, myWorld, originalVideo);
			do
			{
				pad1 = pad2 = 0;
				JoypadScanDirection(0, &pad1);
				JoypadScanDirection(1, &pad2);
			}	
			while (((pad1 & 0x0400) || (pad2 & 0x0400)) && (TickCount() < (startTime + repeatDelay)));
		}
		
		while (ISpKeyIsPressed(kISp1PA) ||
			   ISpKeyIsPressed(kISp2PA) ||
			   ISpKeyIsPressed(kISp1PB) ||
			   ISpKeyIsPressed(kISp2PB) ||
			   ISpKeyIsPressed(kISp1PX) ||
			   ISpKeyIsPressed(kISp2PX) ||
			   ISpKeyIsPressed(kISp1PY) ||
			   ISpKeyIsPressed(kISp2PY))
			result = current_selection;

		UpdateActiveFrame(current_selection, myWorld, originalVideo);
	}
	while (result == -2);
	
	clickSound = (SndListHandle) GetResource('snd ', 128);
	if (clickSound)
	{
		SndPlay(nil, clickSound, false);
		ReleaseResource((Handle) clickSound);
	}
	
	if (originalVideo != nil)
		DisposePtr(originalVideo);
	FinishGDrawing(myWorld);
	DisposeGWorld(myWorld);

	S9xSetSoundMute(!Settings.APUEnabled);

	return result;	
}

void S9xExit(void)
{
	SysBeep(1);
	
	running = false;
	cartOpen = false;

	QuitApplicationEventLoop();
}

Boolean IsLockedMedia(FSVolumeRefNum volume)
{
    OSErr			err;
	FSVolumeInfo	info;
	
	err = FSGetVolumeInfo(volume, 0, nil, kFSVolInfoFlags, &info, nil, nil);
    if (err == noErr)
	{
		if ((info.flags & kFSVolFlagHardwareLockedMask) || (info.flags & kFSVolFlagSoftwareLockedMask))
			return true;
	}
	
	return false;
}

void InitClut(void)
{
	PaletteHandle	tempPalette;
	
	tempPalette = NewPalette(256, nil, pmExplicit | pmTolerant, 0);
				   
	myColorTable = (CTabHandle) NewHandleClear(sizeof(ColorTable) - sizeof(ColorSpec));
	Palette2CTab(tempPalette, myColorTable);

	DisposePalette(tempPalette);

	HLock((Handle) myColorTable);
}

void DeinitClut(void)
{
	if (myColorTable)
		DisposeHandle((Handle) myColorTable);
}

void InitGraphics(void)
{		
	#define	BYTES_PER_PIXEL	2
	
	short	safebuffersize = 520 * 520 * BYTES_PER_PIXEL - 512 * 512 * BYTES_PER_PIXEL;
	
	GFX.Pitch      = 512 * BYTES_PER_PIXEL;
	
	snesScreenA    = (uint8 *) calloc(520 * 520 * BYTES_PER_PIXEL, 1);
	snesScreenB    = (uint8 *) calloc(520 * 520 * BYTES_PER_PIXEL, 1);
	blitGLBuffer   = (uint8 *) calloc(512 * 512 * BYTES_PER_PIXEL, 1);
	
	gfxScreenA     = snesScreenA + (safebuffersize >> 1);
	gfxScreenB     = snesScreenB + (safebuffersize >> 1);
	
	GFX.Screen     = gfxScreenA;
	GFX.SubScreen  = (uint8 *) calloc((GFX.Pitch * 512), 1);
	GFX.ZBuffer    = (uint8 *) calloc((GFX.Pitch >> 1) * IMAGE_HEIGHT, 1);
	GFX.SubZBuffer = (uint8 *) calloc((GFX.Pitch >> 1) * IMAGE_HEIGHT, 1);
    
    if (!snesScreenA || !snesScreenB || !blitGLBuffer || !GFX.SubScreen || !GFX.ZBuffer || !GFX.SubZBuffer)
		ExitToShell();
		
	Init_2xSaI(555);
}

void DeinitGraphics(void)
{
	if (snesScreenA)
		free(snesScreenA);
	if (snesScreenB)
		free(snesScreenB);	
	if (blitGLBuffer)
		free(blitGLBuffer);
	if (GFX.SubScreen)
		free(GFX.SubScreen);
	if (GFX.ZBuffer)
		free(GFX.ZBuffer);
	if (GFX.SubZBuffer)
		free(GFX.SubZBuffer);
}

void Deinitialize(void)
{
	ExitMovies();
	DeinitRecentMenu();
	DeinitRecentItems();
	SavePrefs();	
	ReleaseHID();
	DeinitCheatFinder();
	DeinitClut();
	DeinitGraphics();
	DeinitKeyboard();		
	DeinitMacSound();
	DeinitAppleEvents();
}

void Initialize(void)
{
	OSStatus		err;
	CFStringRef		ref;
	IBNibRef		menuNibRef;
	MenuHandle		menu;
		
	InitCursor();
	FlushEvents(everyEvent, 0L);
	
	err = Gestalt(gestaltSystemVersion, &systemVersion);
	
    ZeroMemory(&Settings, sizeof(Settings));
	
    Settings.ShutdownMaster = true;
    Settings.CyclesPercentage = 100;
	Settings.SoundSkipMethod = 3;
    Settings.H_Max = SNES_CYCLES_PER_SCANLINE;
    Settings.HBlankStart = (256 * Settings.H_Max) / SNES_HCOUNTER_MAX;
    Settings.DisableIRQ = false;
	Settings.Paused = false;
	Settings.ForcedPause = false;
	Settings.StopEmulation = false;

    Settings.FrameTimePAL = 20000;
    Settings.FrameTimeNTSC = 16667;
    Settings.FrameTime = Settings.FrameTimeNTSC;
    Settings.SkipFrames = 3;

    Settings.Mouse = false;
	Settings.MouseMaster = false;
	Settings.SuperScope = false;
	Settings.SuperScopeMaster = false;
    Settings.MultiPlayer5 = false;
	Settings.MultiPlayer5Master = false;
	Settings.Justifier = false;
	Settings.SecondJustifier = false;
	Settings.JustifierMaster = false;
	Settings.ControllerOption = SNES_JOYPAD;
	
    Settings.APUEnabled = true;
    Settings.SoundPlaybackRate = 32000;
    Settings.Stereo = true;
    Settings.ReverseStereo = false;
    Settings.SixteenBitSound = true;
	Settings.SoundEnvelopeHeightReading = true;
    Settings.DisableSampleCaching = true;
	Settings.AltSampleDecode = 0;
    Settings.InterpolatedSound = true;
    Settings.NextAPUEnabled = true;
	Settings.SoundSync = false; // if true, FF4 is broken.
	Settings.DisableSoundEcho = false;
	Settings.DisableMasterVolume = false;

    Settings.SixteenBit = true;
    Settings.Transparency = true;
    Settings.SupportHiRes = true;
    Settings.Mode7Interpolate = true;

	Settings.NetPlay = false;
    Settings.ServerName[0] = 0;
	Settings.ApplyCheats = true;
	Settings.SwapJoypads = false;
	Settings.AutoSaveDelay = 0;
	
	Settings.SampleCatchup = false;
	Settings.TakeScreenshot = false;

	err = RegisterAppearanceClient();
	
	InitAppleEvents();
	InitMacSound();
	InitKeyboard();
	InitGraphics();
 	InitClut();
	InitMP();
	InitAutoFire();
	InitCheatFinder();
	
   	LoadPrefs();
	
	SetUpHID();
	
	err = CreateNibReference(CFSTR("SNES9X"), &menuNibRef);
	err = SetMenuBarFromNib(menuNibRef, CFSTR("MenuBar"));
	DisposeNibReference(menuNibRef);

	EnableMenuCommand(nil, kHICommandPreferences);
	DisableMenuItem(GetMenuHandle(mEdit), 0);
	
	if (scopecursor)
		ref = CFCopyLocalizedString(CFSTR("HideScopeCursor"), "hide");
	else
		ref = CFCopyLocalizedString(CFSTR("ShowScopeCursor"), "show");
	err = SetMenuItemTextWithCFString(GetMenuHandle(mEmulation), iScopeCursor, ref);
	CFRelease(ref);

	CheckMenuItem(GetMenuHandle(mCheat), iApplyCheats, applycheat);
	Settings.ApplyCheats = applycheat;
	
	CheckMenuItem(GetMenuHandle(mEmulation), iSwapPad, Settings.SwapJoypads);

	err = GetMenuItemHierarchicalMenu(GetMenuHandle(mControl), iISpPreset, &menu);
	CheckMenuItem(menu, padSetting, true);
	
	err = GetMenuItemHierarchicalMenu(GetMenuHandle(mEmulation), iDevice, &menu);
	CheckMenuItem(menu, deviceSetting, true);
	
	InitRecentItems();
	InitRecentMenu();
	BuildRecentMenu();
	
	DrawMenuBar();
	
	autofire = (autofireRec[0].buttonMask || autofireRec[1].buttonMask) ? true : false;
	
	ChangeInputDevice();

	EnterMovies(); 
	
	if (!Memory.Init() || !S9xInitAPU() || !S9xGraphicsInit())
		ExitToShell();
}

void ChangeInputDevice(void)
{
	switch (deviceSetting)
	{
		case iPad:
			mouseActive = false;
			Settings.ControllerOption = SNES_JOYPAD;
			Settings.Mouse = false;
			Settings.SuperScope = false;
			Settings.MultiPlayer5 = false;
			Settings.Justifier = false;
			Settings.SecondJustifier = false;
			break;
		
		case iMouse:
			mouseActive = true;
			Settings.ControllerOption = SNES_MOUSE_SWAPPED;
			Settings.Mouse = true;
			Settings.SuperScope = false;
			Settings.MultiPlayer5 = false;
			Settings.Justifier = false;
			Settings.SecondJustifier = false;
			break;
			
		case iMouse2:
			mouseActive = true;
			Settings.ControllerOption = SNES_MOUSE;
			Settings.Mouse = true;
			Settings.SuperScope = false;
			Settings.MultiPlayer5 = false;
			Settings.Justifier = false;
			Settings.SecondJustifier = false;
			break;
			
		case iSuperScope:
			mouseActive = true;
			Settings.ControllerOption = SNES_SUPERSCOPE;
			Settings.Mouse = false;
			Settings.SuperScope = true;
			Settings.MultiPlayer5 = false;
			Settings.Justifier = false;
			Settings.SecondJustifier = false;
			break;
			
		case iMultiPlayer5:
			mouseActive = false;
			Settings.ControllerOption = SNES_MULTIPLAYER5;
			Settings.Mouse = false;
			Settings.SuperScope = false;
			Settings.MultiPlayer5 = true;
			Settings.Justifier = false;
			Settings.SecondJustifier = false;
			break;
			
		case iJustifier1:
			mouseActive = true;
			Settings.ControllerOption = SNES_JUSTIFIER;
			Settings.Mouse = false;
			Settings.SuperScope = false;
			Settings.MultiPlayer5 = false;
			Settings.Justifier = true;
			Settings.SecondJustifier = false;
			break;
			
		case iJustifier2:
			mouseActive = true;
			Settings.ControllerOption = SNES_JUSTIFIER_2;
			Settings.Mouse = false;
			Settings.SuperScope = false;
			Settings.MultiPlayer5 = false;
			Settings.Justifier = false;
			Settings.SecondJustifier = true;
	}

	Settings.JustifierMaster = Settings.Justifier | Settings.SecondJustifier;
}

void _splitpath(const char *path, char *drive, char *dir, char *fname, char *ext)
{
	short	x;
	
	drive[0] = '\0';
	fname[0] = '\0';
	ext[0]   = '\0';
	dir[0]   = '\0';
	
	if (strlen(path) < 1)
		return;
	
	x = strlen(path) - 1;
	while (x && (path[x] != '/'))
		x--;
	
	if (x)
	{
		strcpy(dir, path);
		dir[x + 1] = '\0';
		
		strcpy(fname, path + x + 1);
	}
	else
		strcpy(fname, path);
	
	x = strlen(fname);
	while (x && (fname[x] != '.'))
		x--;
	
	if (x)
	{
		strcpy(ext, fname + x);
		fname[x] = '\0';
	}
}

void _makepath(char *path, const char *drive, const char *dir, const char *fname, const char *ext)
{
	#pragma unused (drive)

	path[0] = '\0';

	if (dir && dir[0])
		strcat(path, dir);
	
	if (fname && fname[0])
		strcat(path, fname);
	
	if (ext && ext[0])
		strcat(path, ext);
}
   
void S9xSyncSpeed(void)
{
	long long	currentFrame, adjustment;
	int			soundBuffersToQueue;
	
	soundBuffersToQueue = macBufferCount / 12;
	
	if (soundQueued < soundBuffersToQueue)
	{
		int	sample_count;
		
		sample_count = so.buffer_size;
		if (so.sixteen_bit)
			sample_count >>= 1;
		
		S9xMixSamples((uint8 *) soundBuffer[soundBufferAt], sample_count);
		if (++soundBufferAt >= macBufferCount)
			soundBufferAt = 0;

		soundQueued++;
	}
	
	#ifdef MK_APU
	if (SoundData.sample_cycles < 0)
		SoundData.sample_cycles = 0;
	#endif

	if (directDisplay)
	{
		Settings.SkipFrames--;
		
		if (Settings.SkipFrames <= 0)
		{
			adjustment = (gFastForward ? (1000000 / kFastForwardRate) : 1000000) / Memory.ROMFramesPerSecond;
			Microseconds((UnsignedWide *) &currentFrame);
			
			Settings.SkipFrames = ((currentFrame - lastFrame) / adjustment);
			lastFrame += frameCount * adjustment;

			if (Settings.SkipFrames < 1)
				Settings.SkipFrames = 1;
			if (Settings.SkipFrames > 7)
			{
				Settings.SkipFrames = 7;
				Microseconds((UnsignedWide *) &lastFrame);
			}

			frameCount = Settings.SkipFrames;

			while (lastFrame > currentFrame)
			{
				MPYield();
				Microseconds((UnsignedWide *) &currentFrame);
			}
			
			IPPU.RenderThisFrame = true;
		}
		else
			IPPU.RenderThisFrame = false;
	}
	else
		IPPU.RenderThisFrame = false;
}

void AddFolderIcon(FSRef *folderRef, const char *folderName)
{
	OSErr			err;
	FSRef			iconRef;
	FSSpec			iconFile;
	FSCatalogInfo	iconInfo, folderInfo;
	Handle			res;
	Str255			folderNameP;
	long			writeAmount;
	short			refNum;
	UniChar			iconName[5] = { 'I', 'c', 'o', 'n', '\r' };
		
	ConvertCString(folderName, folderNameP);
	res = GetNamedResource('fork', folderNameP);		
	if (res)
	{
		HLock(res);
		
		err = FSCreateFileUnicode(folderRef, 5, iconName, kFSCatInfoNone, nil, &iconRef, &iconFile);
		if (err == noErr)
		{
			FSpCreateResFile(&iconFile, 'MACS', 'icon', smSystemScript);
				
			err = FSpOpenRF(&iconFile, fsWrPerm, &refNum);
			if (err == noErr)
			{
				writeAmount = GetHandleSize(res);
				err = FSWrite(refNum, &writeAmount, *res);
				FSClose(refNum);
					
				err = FSGetCatalogInfo(&iconRef, kFSCatInfoFinderInfo, &iconInfo, nil, nil, nil);
				((FileInfo *) &iconInfo.finderInfo)->finderFlags |= kIsInvisible;
				err = FSSetCatalogInfo(&iconRef, kFSCatInfoFinderInfo, &iconInfo);

				err = FSGetCatalogInfo(folderRef, kFSCatInfoFinderInfo, &folderInfo, nil, nil, nil);
				((FolderInfo *) &folderInfo.finderInfo)->finderFlags |=  kHasCustomIcon;
				((FolderInfo *) &folderInfo.finderInfo)->finderFlags &= ~kHasBeenInited;
				err = FSSetCatalogInfo(folderRef, kFSCatInfoFinderInfo, &folderInfo);
			}
		}
	
		HUnlock(res);
	}
}

OSErr FindSNESFolder(FSRef *folderRef, char *folderPath, const char *folderName)
{
	OSStatus	err;
	CFURLRef	burl, purl;
	CFStringRef	fstr;
	FSRef		pref;
	UniChar		buffer[PATH_MAX + 1];
	Boolean		r;
	
	fstr = CFStringCreateWithCString(kCFAllocatorDefault, folderName, CFStringGetSystemEncoding());
	CFStringGetCharacters(fstr, CFRangeMake(0, CFStringGetLength(fstr)), buffer);

	burl = CFBundleCopyBundleURL(CFBundleGetMainBundle());
	purl = CFURLCreateCopyDeletingLastPathComponent(kCFAllocatorDefault, burl);
	r    = CFURLGetFSRef(purl, &pref);
	
	err = FSMakeFSRefUnicode(&pref, CFStringGetLength(fstr), buffer, kTextEncodingUnicodeDefault, folderRef);
 	if (err == dirNFErr || err == fnfErr) 
	{
		err = FSCreateDirectoryUnicode(&pref, CFStringGetLength(fstr), buffer, kFSCatInfoNone, nil, folderRef, nil, nil);
		if (err == noErr)
			AddFolderIcon(folderRef, folderName);
	}
	
	if (err != noErr && !folderWarning)
	{
		AppearanceAlert(kAlertCautionAlert, kFolderFail, kFolderHint);
		folderWarning = true;
	}
	else
		err = FSRefMakePath(folderRef, folderPath, PATH_MAX);
		
	CFRelease(purl);
	CFRelease(burl);
	CFRelease(fstr);

	return err;
}

OSErr FindApplicationSupportFolder(FSRef *folderRef, char *folderPath, const char *folderName)
{
	OSErr		err;
	FSRef		p2ref, p1ref;
	CFStringRef	fstr;
	UniChar		buffer[PATH_MAX + 1];
	UniChar		s9xfolder[6] = { 'S', 'N', 'E', 'S', '9', 'X' };
			
	err = FSFindFolder(kUserDomain, kApplicationSupportFolderType, kCreateFolder, &p2ref);
	if (err)
		return (err);

	err = FSMakeFSRefUnicode(&p2ref, 6, s9xfolder, kTextEncodingUnicodeDefault, &p1ref);
	if (err == dirNFErr || err == fnfErr)
		err = FSCreateDirectoryUnicode(&p2ref, 6, s9xfolder, kFSCatInfoNone, nil, &p1ref, nil, nil);
	if (err)
		return (err);
		
	fstr = CFStringCreateWithCString(kCFAllocatorDefault, folderName, CFStringGetSystemEncoding());
	CFStringGetCharacters(fstr, CFRangeMake(0, CFStringGetLength(fstr)), buffer);

	err = FSMakeFSRefUnicode(&p1ref, CFStringGetLength(fstr), buffer, kTextEncodingUnicodeDefault, folderRef);
 	if (err == dirNFErr || err == fnfErr)
	{
		err = FSCreateDirectoryUnicode(&p1ref, CFStringGetLength(fstr), buffer, kFSCatInfoNone, nil, folderRef, nil, nil);
		if (err == noErr)
			AddFolderIcon(folderRef, folderName);
	}
	
	if (err != noErr && !folderWarning)
	{
		AppearanceAlert(kAlertCautionAlert, kFolderFail, kFolderHint);
		folderWarning = true;
	}
	else
		err = FSRefMakePath(folderRef, folderPath, PATH_MAX);

	CFRelease(fstr);
	
	return err;
}

const char * S9xGetFilename(const char *inExt)
{
	static char	filePath[PATH_MAX + 1];

	OSErr	err;
	FSRef	ref;
	char	folderName[16];
	char	drive[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], ext[_MAX_EXT];
	
	folderName[0] = filePath[0] = 0;
	
	if (strlen(inExt) < 4)
		return filePath;
	
	switch (*(long *) (inExt + strlen(inExt) - 4))
	{
		case '.srm':
		case '.dat':
		case '.rtc':
			strcpy(folderName, "SRAMs");
			break;
		
		case '.frz':
			strcpy(folderName, "Freezes");
			break;

		case '.spc':
			strcpy(folderName, "SPCs");
			break;
		
		case '.cht':
			strcpy(folderName, "Cheats");
			break;
			
		case '.ips':
			strcpy(folderName, "IPSs");
			break;
			
		case '.png':
			strcpy(folderName, "Screenshots");
			break;
			
		case '.pac':	// dummy
			strcpy(folderName, "Packs");
	}

	if (folderName[0] && ((saveInROMFolder != 1) || lockedROMMedia))
	{
		if (saveInROMFolder == 0)
			err = FindSNESFolder(&ref, filePath, folderName);
		else
			err = FindApplicationSupportFolder(&ref, filePath, folderName);
			
		if (err == noErr)
		{			
			_splitpath(Memory.ROMFilename, drive, dir, fname, ext);
			strcat(filePath, "/");
			strcat(filePath, fname);
			strcat(filePath, inExt);
		}
		else
		{
			_splitpath(Memory.ROMFilename, drive, dir, fname, ext);
			_makepath(filePath, drive, dir, fname, inExt);
		}
	}
	else
	{
	    _splitpath(Memory.ROMFilename, drive, dir, fname, ext);
		_makepath(filePath, drive, dir, fname, inExt);
	}

	return filePath;
}

const char * S9xGetSPCFilename(void)
{
	char	spcExt[16];
	
	sprintf(spcExt, ".%03d.spc", (int) spcFileCount);
	
	spcFileCount++;
	if (spcFileCount == 999)
		spcFileCount = 0;

	return S9xGetFilename(spcExt);
}

const char * S9xGetPNGFilename(void)
{
	char	pngExt[16];
	
	sprintf(pngExt, ".%03d.png", (int) pngFileCount);
	
	pngFileCount++;
	if (pngFileCount == 999)
		pngFileCount = 0;

	return S9xGetFilename(pngExt);
}

const char * S9xGetFreezeFilename(int which)
{
	char	frzExt[16];
	
	sprintf(frzExt, ".%03d.frz", which);
	
	return S9xGetFilename(frzExt);
}

void ClearGFXScreen(void)
{
	UInt16	*p, *q, x, y;
	
	p = (UInt16 *) gfxScreenA;
	q = (UInt16 *) gfxScreenB;
	
	for (x = 0; x < 512; x++)
		for (y = 0; y < 512; y++)
			*p++ = *q++ = 0;
			
	BlitUpdateEntireDelta();
	
	if (drawingMethod == kDrawingDirect)
		S9xPutImageDirect(512, 480);
	else
	{		
		if (fullscreen)
		{
			CGLSetCurrentContext(glContext);
			glViewport(0, 0, glScreenW, glScreenH);
		}
		else
		{
			aglSetCurrentContext(agContext);
			glViewport(0, 0, 512, 480);
		}
		
		for (int i = 0; i < 2; i++)
		{
			glClearColor(0.0, 0.0, 0.0, 0.0);
			glClear(GL_COLOR_BUFFER_BIT);
			glFlush();
		
			if (fullscreen)
				CGLFlushDrawable(glContext);
			else
				aglSwapBuffers(agContext);
		}
	}
}

void S9xInitFullScreen(void)
{
	CFDictionaryRef	mode;
	boolean_t		exactMatch;
	size_t 			width, height;
	int				depth = 16;
	
	DeinitGameWindow();

	oldDisplayMode = CGDisplayCurrentMode(kCGDirectMainDisplay);

	if (autoRes)
	{
		width  = 640;
		height = 480;
	}
	else
	{
		width  = CGDisplayPixelsWide(kCGDirectMainDisplay);
		height = CGDisplayPixelsHigh(kCGDirectMainDisplay);
	}
	
	if (((drawingMethod == kDrawingOpenGL) || (drawingMethod == kDrawingBlitGL)) && gl32bit)
		depth = 32;
	
	mode = CGDisplayBestModeForParameters(kCGDirectMainDisplay, depth, width, height, &exactMatch);
	
	CGDisplayCapture(kCGDirectMainDisplay);
	CGDisplaySwitchToMode(kCGDirectMainDisplay, mode);

	if (((Settings.ControllerOption == SNES_SUPERSCOPE ) ||
		 (Settings.ControllerOption == SNES_JUSTIFIER  ) ||
		 (Settings.ControllerOption == SNES_JUSTIFIER_2)) && scopecursor)
	{
		CursHandle	crsr;

		crsr = GetCursor(128);
		SetCursor(*crsr);
	}
	else
	{
		CGDisplayHideCursor(kCGDirectMainDisplay);
		
		if ((Settings.ControllerOption == SNES_MOUSE) || (Settings.ControllerOption == SNES_MOUSE_SWAPPED))
			CGDisplayMoveCursorToPoint(kCGDirectMainDisplay, CGPointMake((float) (width >> 1), (float) (height >> 1)));
	}
}

void S9xInitWindowMode(void)
{
	CGrafPtr		port;
	CGContextRef	ctx;
	CGRect			crt;
	CFDictionaryRef	mode;
	boolean_t		exactMatch;
	size_t			width, height;
	int				depth = 16;
	
	oldDisplayMode = CGDisplayCurrentMode(kCGDirectMainDisplay);
	
	width  = CGDisplayPixelsWide(kCGDirectMainDisplay);
	height = CGDisplayPixelsHigh(kCGDirectMainDisplay);
	
	if (((drawingMethod == kDrawingOpenGL) || (drawingMethod == kDrawingBlitGL)) && gl32bit)
		depth = 32;

	mode = CGDisplayBestModeForParameters(kCGDirectMainDisplay, depth, width, height, &exactMatch);
	
	CGDisplaySwitchToMode(kCGDirectMainDisplay, mode);

	if (((Settings.ControllerOption == SNES_SUPERSCOPE ) ||
		 (Settings.ControllerOption == SNES_JUSTIFIER  ) ||
		 (Settings.ControllerOption == SNES_JUSTIFIER_2)) && scopecursor)
	{
		CursHandle	crsr;

		crsr = GetCursor(128);
		SetCursor(*crsr);
	}
	else
	if (!allowevent || (drawingMethod == kDrawingDirect))
		CGDisplayHideCursor(kCGDirectMainDisplay);

	DisableMenus();
	
	InitGameWindow();
	
	GetWindowBounds(gWindow, kWindowContentRgn, &gWindowRect);
	
	port = GetWindowPort(gWindow);
	if (!CreateCGContextForPort(port, &ctx))
	{
		CGContextSetLineWidth(ctx, 0);
		
		crt = CGRectMake(0.0, 0.0, 512.0, 480.0);
		CGContextSetRGBFillColor(ctx, 0.0, 0.0, 0.0, 1.0);
		CGContextBeginPath(ctx);
		CGContextAddRect(ctx, crt);	
		CGContextClosePath(ctx);
		CGContextFillPath(ctx);
		
		CGContextFlush(ctx);
		
		CGContextRelease(ctx);
	}
}

void S9xDeinitFullScreen(void)
{
	if (((Settings.ControllerOption == SNES_SUPERSCOPE ) ||
		 (Settings.ControllerOption == SNES_JUSTIFIER  ) ||
		 (Settings.ControllerOption == SNES_JUSTIFIER_2)) && scopecursor)
		InitCursor();
	else
		CGDisplayShowCursor(kCGDirectMainDisplay);
    
	CGDisplaySwitchToMode(kCGDirectMainDisplay, oldDisplayMode);
    CGDisplayRelease(kCGDirectMainDisplay);
}

void S9xDeinitWindowMode(void)
{
	if (((Settings.ControllerOption == SNES_SUPERSCOPE ) ||
		 (Settings.ControllerOption == SNES_JUSTIFIER  ) ||
		 (Settings.ControllerOption == SNES_JUSTIFIER_2)) && scopecursor)
		InitCursor();
	else
	if (!allowevent || (drawingMethod == kDrawingDirect))
		CGDisplayShowCursor(kCGDirectMainDisplay);

    CGDisplaySwitchToMode(kCGDirectMainDisplay, oldDisplayMode);
	
	DrawPauseScreen();

	EnableMenus();
}

void S9xInitOpenGLFullScreen(void)
{
	CGOpenGLDisplayMask	displayMask;
	CGLPixelFormatObj	pixelFormat;
	long 				numPixelFormats;
					
	displayMask = CGDisplayIDToOpenGLDisplayMask(kCGDirectMainDisplay);
	CGLPixelFormatAttribute	attribs[] = { kCGLPFAFullScreen,
										  kCGLPFADoubleBuffer,
										  kCGLPFAAccelerated,
										  kCGLPFANoRecovery,
										  kCGLPFAColorSize,   gl32bit ? 32 : 16,
										  kCGLPFADisplayMask, displayMask,
										  0 };
										  
	CGLChoosePixelFormat(attribs, &pixelFormat, &numPixelFormats);
	CGLCreateContext(pixelFormat, nil, &glContext);
	CGLDestroyPixelFormat(pixelFormat);
	glSwapInterval = vsync ? 1 : 0;
	CGLSetParameter(glContext, kCGLCPSwapInterval, &glSwapInterval);
	CGLSetCurrentContext(glContext);
	CGLSetFullScreen(glContext);
	
	glScreenW = CGDisplayPixelsWide(kCGDirectMainDisplay);
	glScreenH = CGDisplayPixelsHigh(kCGDirectMainDisplay);
}

void S9xInitOpenGLWindowMode(void)
{
	AGLPixelFormat 	pixelFormat;

	GLint	attribs[] = { AGL_RGBA,
						  AGL_DOUBLEBUFFER,
						  AGL_ACCELERATED,
						  AGL_NO_RECOVERY,
						  AGL_PIXEL_SIZE, gl32bit ? 32 : 16,
						  AGL_NONE };

	pixelFormat = aglChoosePixelFormat(nil, 0, attribs);
	agContext = aglCreateContext(pixelFormat, nil);
	aglSetDrawable(agContext, GetWindowPort(gWindow));
	agSwapInterval = vsync ? 1 : 0;
	aglSetInteger(agContext, AGL_SWAP_INTERVAL, &agSwapInterval);
	aglDestroyPixelFormat(pixelFormat);
	aglSetCurrentContext(agContext);
}

void S9xInitDirectFullScreen(void)
{
	size_t	offsetX, offsetY;
	
	glScreenW = CGDisplayPixelsWide(kCGDirectMainDisplay);
	glScreenH = CGDisplayPixelsHigh(kCGDirectMainDisplay);
	
	offsetX = (glScreenW - 512) / 2;
	offsetY = (glScreenH - 480) / 2;

	gMacRowBytes  = CGDisplayBytesPerRow(kCGDirectMainDisplay);
	gMacScreenPtr = (unsigned char *) CGDisplayBaseAddress(kCGDirectMainDisplay);			
	gWinScreenPtr = gMacScreenPtr + offsetY * gMacRowBytes + offsetX * 2;
	
	BlitFn256x240 = doubleSize ? (saiMode ? BlitPix2xSaI16 : (eagleMode ? BlitPixEagle16 : (tvMode ? BlitPixScaledTV16 : (smoothMode ? BlitPixFiltered16 : BlitPixScaled16)))) : BlitPixSmall16;
	BlitFn512x240 = tvMode ? BlitPixHiResTV16 : BlitPixHiRes16;
	BlitFn512x480 = BlitPixSmall16;
	
	BlitUpdateEntireDelta();
	
	if (multiprocessor)
	{
		printf("MP: Creating DirectDraw thread.\n");
		
		if (noErr != PrepareMPBlit())
			multiprocessor = false;	
	}
}

void S9xInitDirectWindowMode(void)
{
	size_t	offsetX, offsetY;
	
	offsetX = gWindowRect.left;
	offsetY = gWindowRect.top;

	gMacRowBytes  = CGDisplayBytesPerRow(kCGDirectMainDisplay);
	gMacScreenPtr = (unsigned char *) CGDisplayBaseAddress(kCGDirectMainDisplay);			
	gWinScreenPtr = gMacScreenPtr + offsetY * gMacRowBytes + offsetX * 2;
	
	BlitFn256x240 = doubleSize ? (saiMode ? BlitPix2xSaI16 : (eagleMode ? BlitPixEagle16 : (tvMode ? BlitPixScaledTV16 : (smoothMode ? BlitPixFiltered16 : BlitPixScaled16)))) : BlitPixSmall16;
	BlitFn512x240 = tvMode ? BlitPixHiResTV16 : BlitPixHiRes16;
	BlitFn512x480 = BlitPixSmall16;

	BlitUpdateEntireDelta();

	if (multiprocessor)
	{
		printf("MP: Creating DirectDraw thread.\n");
		
		if (noErr != PrepareMPBlit())
			multiprocessor = false;
	}
}

void S9xInitBlitGL(void)
{
	if (multiprocessor)
	{
		printf("MP: Creating BlitGL thread.\n");
		
		if (noErr != PrepareMPBlitGL())
			multiprocessor = false;	
	}
}

#define kGL256256	0
#define	kGL512256	1
#define	kGL512512	2
#define	kGLBlit		3

void S9xInitOpenGLContext(void)
{
	OpenGL.internal_format = GL_RGB5_A1;
	OpenGL.format          = GL_BGRA;
	OpenGL.type            = GL_UNSIGNED_SHORT_1_5_5_5_REV;

	glGenTextures(4, OpenGL.textures);
	
	// 256 * 256
	
	glBindTexture(GL_TEXTURE_2D, OpenGL.textures[kGL256256]);
	glPixelStorei(GL_UNPACK_CLIENT_STORAGE_APPLE, 1);
	glTexImage2D(GL_TEXTURE_2D, 0, OpenGL.internal_format, 256, 256, 0, OpenGL.format, OpenGL.type, GFX.Screen);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
	if (smoothMode)
	{
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	}
	else
	{
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
	}
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
	
	// 512 * 256
	
	glBindTexture(GL_TEXTURE_2D, OpenGL.textures[kGL512256]);
	glPixelStorei(GL_UNPACK_CLIENT_STORAGE_APPLE, 1);
	glTexImage2D(GL_TEXTURE_2D, 0, OpenGL.internal_format, 512, 256, 0, OpenGL.format, OpenGL.type, GFX.Screen);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
	if (smoothMode)
	{
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	}
	else
	{
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
	}
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);

	// 512 * 512
	
	glBindTexture(GL_TEXTURE_2D, OpenGL.textures[kGL512512]);
	glPixelStorei(GL_UNPACK_CLIENT_STORAGE_APPLE, 1);
	glTexImage2D(GL_TEXTURE_2D, 0, OpenGL.internal_format, 512, 512, 0, OpenGL.format, OpenGL.type, GFX.Screen);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
	if (smoothMode)
	{
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	}
	else
	{
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
	}
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
	
	// Blit (512 * 512)
	
	glBindTexture(GL_TEXTURE_2D, OpenGL.textures[kGLBlit]);
	glPixelStorei(GL_UNPACK_CLIENT_STORAGE_APPLE, 1);
	glTexImage2D(GL_TEXTURE_2D, 0, OpenGL.internal_format, 512, 512, 0, OpenGL.format, OpenGL.type, blitGLBuffer);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
	
	//

	glEnable(GL_CULL_FACE);
	glPolygonMode(GL_FRONT, GL_FILL);
	glCullFace(GL_BACK);
	
	glEnable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	glDisable(GL_DITHER);
	glDisable(GL_LIGHTING);
	glDisable(GL_DEPTH_TEST);
	
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glMatrixMode(GL_MODELVIEW);
	
	if (fullscreen)
	{
		CGLSetCurrentContext(glContext);
		glViewport(0, 0, glScreenW, glScreenH);
	}
	else
	{
		aglSetCurrentContext(agContext);
		glViewport(0, 0, 512, 480);
	}
	
	for (int i = 0; i < 2; i++)
	{
		glClearColor(0.0, 0.0, 0.0, 0.0);
		glClear(GL_COLOR_BUFFER_BIT);
		glFlush();
	
		if (fullscreen)
			CGLFlushDrawable(glContext);
		else
			aglSwapBuffers(agContext);
	}
}

void S9xDeinitOpenGLContext(void)
{
	glDeleteTextures(4, OpenGL.textures);
}

void S9xDeinitBlitGL(void)
{
	if (multiprocessor)
	{		
		MPNotifyQueue(taskQueue, (void *) kMPBlitDone, 0, 0);
		MPWaitOnQueue(notificationQueue, nil, nil, nil, kDurationForever);
		MPDeleteQueue(notificationQueue);
		notificationQueue = nil;

		printf("MP: Successfully received terminate signal from BlitGL thread.\n");
	}
}

void S9xDeinitDirectWindowMode(void)
{
	if (multiprocessor)
	{
		MPNotifyQueue(taskQueue, (void *) kMPBlitDone, 0, 0);
		MPWaitOnQueue(notificationQueue, nil, nil, nil, kDurationForever);
		MPDeleteQueue(notificationQueue);
		notificationQueue = nil;

		printf("MP: Successfully received terminate signal from DirectDraw thread.\n");
	}
}

void S9xDeinitDirectFullScreen(void)
{
	if (multiprocessor)
	{
		MPNotifyQueue(taskQueue, (void *) kMPBlitDone, 0, 0);
		MPWaitOnQueue(notificationQueue, nil, nil, nil, kDurationForever);
		MPDeleteQueue(notificationQueue);
		notificationQueue = nil;

		printf("MP: Successfully received terminate signal from DirectDraw thread.\n");
	}
}

void S9xDeinitOpenGLWindowMode(void)
{
	if (agContext)
	{
		aglSetDrawable(agContext, nil);
		aglSetCurrentContext(nil);
		aglDestroyContext(agContext);
	}
}

void S9xDeinitOpenGLFullScreen(void)
{
	if (glContext)
	{
		CGLSetCurrentContext(nil);
		CGLClearDrawable(glContext);
		CGLDestroyContext(glContext);
	}
}

void S9xInitDisplay(int argc, char **argv)
{
	#pragma unused (argc, argv)
	
	if (directDisplay)
		return;

	if (fullscreen)
	{
		S9xInitFullScreen();
		
		switch (drawingMethod)
		{
			case kDrawingOpenGL:
				gSrcP = 512;
				Settings.OpenGLEnable = true;
				S9xInitOpenGLFullScreen();
				S9xInitOpenGLContext();
				break;
				
			case kDrawingDirect:
				gSrcP = 1024;
				Settings.OpenGLEnable = false;
				S9xInitDirectFullScreen();
				break;
				
			case kDrawingBlitGL:
				gSrcP = 512;
				Settings.OpenGLEnable = true;
				S9xInitOpenGLFullScreen();
				S9xInitOpenGLContext();
				S9xInitBlitGL();
		}
	}
	else
	{
		S9xInitWindowMode();

		switch (drawingMethod)
		{
			case kDrawingOpenGL:
				gSrcP = 512;
				Settings.OpenGLEnable = true;
				S9xInitOpenGLWindowMode();
				S9xInitOpenGLContext();
				break;
				
			case kDrawingDirect:
				gSrcP = 1024;
				Settings.OpenGLEnable = false;
				S9xInitDirectWindowMode();
				break;

			case kDrawingBlitGL:
				gSrcP = 512;
				Settings.OpenGLEnable = true;
				S9xInitOpenGLWindowMode();
				S9xInitOpenGLContext();
				S9xInitBlitGL();
		}
	}
		
	S9xSetSoundMute(!Settings.APUEnabled);
	Microseconds((UnsignedWide *) &lastFrame);

	directDisplay = true;
}

void S9xDeinitDisplay(void)
{
	if (!directDisplay)
		return;
	
	S9xSetSoundMute(true);
	
	if (fullscreen)
	{	
		switch (drawingMethod)
		{
			case kDrawingOpenGL:
				S9xDeinitOpenGLContext();
				S9xDeinitOpenGLFullScreen();
				break;
				
			case kDrawingDirect:
				S9xDeinitDirectFullScreen();
				break;
				
			case kDrawingBlitGL:
				S9xDeinitBlitGL();
				S9xDeinitOpenGLContext();
				S9xDeinitOpenGLFullScreen();
		}
	
		S9xDeinitFullScreen();
	}
	else
	{
		switch (drawingMethod)
		{
			case kDrawingOpenGL:
				S9xDeinitOpenGLContext();
				S9xDeinitOpenGLWindowMode();
				break;
			
			case kDrawingDirect:
				S9xDeinitDirectWindowMode();
				break;
				
			case kDrawingBlitGL:
				S9xDeinitBlitGL();
				S9xDeinitOpenGLContext();
				S9xDeinitOpenGLWindowMode();
		}
		
		S9xDeinitWindowMode();
	}
	
	Settings.OpenGLEnable = false;
	directDisplay = false;
	
	lastDrawingMethod = drawingMethod;
}

void PostQueueToSubEventLoop(void)
{
	OSStatus	err;
	EventRef	event;
	
	err = CreateEvent(kCFAllocatorDefault, kEventClassCommand, kEventCommandProcess, 0, kEventAttributeUserEvent, &event);
	if (err == noErr)
	{
		HICommand	cmd;
		
		cmd.commandID          = 'SubQ';
		cmd.attributes         = kEventAttributeUserEvent;
		cmd.menu.menuRef       = nil;
		cmd.menu.menuItemIndex = 0;
		
		err = SetEventParameter(event, kEventParamDirectObject, typeHICommand, sizeof(HICommand), &cmd);
		if (err == noErr)
			err = PostEventToQueue(GetMainEventQueue(), event, kEventPriorityStandard);
			
		ReleaseEvent(event);
	}
}

void ProcessInput(void)
{
	static uint8	fkey[] = { kmF1Key, kmF2Key, kmF3Key, kmF4Key, kmF5Key };
	static uint8	heldFkey[5];
	
	KeyMap	myKeys;
	int		index;
	
	controlPad[0] = controlPad[1] = 0;

	if (!mouseActive && Button())
	{
		FlushEventQueue(GetCurrentEventQueue());
		running = false;
		return;
	}

	if (ISpKeyIsPressed(kISpScreenshot))
	{
		Settings.TakeScreenshot = true;
		while (ISpKeyIsPressed(kISpScreenshot));
	}
	
	if (ISpKeyIsPressed(kISpSPC))
	{
		spc_is_dumping = 1;
		while (ISpKeyIsPressed(kISpSPC));
	}

	if (ISpKeyIsPressed(kISpEsc))
	{
		if (s9xthreadrunning)
			PostQueueToSubEventLoop();
		else
			running = false;
		
		return;
	}
	
	if (ISpKeyIsPressed(kISpFreeze))
	{
		SNES9X_Freeze();
		ClearGFXScreen();
		return;
	}

	if (ISpKeyIsPressed(kISpDefrost))
	{
		SNES9X_Defrost();
		ClearGFXScreen();
		return;
	}

	JoypadScanDirection(0, &(controlPad[0]));
	if (ISpKeyIsPressed(kISp1PR     ))	controlPad[0] |= 0x0010;
	if (ISpKeyIsPressed(kISp1PL     ))	controlPad[0] |= 0x0020;
	if (ISpKeyIsPressed(kISp1PX     ))	controlPad[0] |= 0x0040;
	if (ISpKeyIsPressed(kISp1PA     ))	controlPad[0] |= 0x0080;
	if (ISpKeyIsPressed(kISp1PStart ))	controlPad[0] |= 0x1000;
	if (ISpKeyIsPressed(kISp1PSelect))	controlPad[0] |= 0x2000;
	if (ISpKeyIsPressed(kISp1PY     ))	controlPad[0] |= 0x4000;
	if (ISpKeyIsPressed(kISp1PB     ))	controlPad[0] |= 0x8000; 

	JoypadScanDirection(1, &(controlPad[1]));
	if (ISpKeyIsPressed(kISp2PR     ))	controlPad[1] |= 0x0010;
	if (ISpKeyIsPressed(kISp2PL     ))	controlPad[1] |= 0x0020;
	if (ISpKeyIsPressed(kISp2PX     ))	controlPad[1] |= 0x0040;
	if (ISpKeyIsPressed(kISp2PA     ))	controlPad[1] |= 0x0080;
	if (ISpKeyIsPressed(kISp2PStart ))	controlPad[1] |= 0x1000;
	if (ISpKeyIsPressed(kISp2PSelect))	controlPad[1] |= 0x2000;
	if (ISpKeyIsPressed(kISp2PY     ))	controlPad[1] |= 0x4000;
	if (ISpKeyIsPressed(kISp2PB     ))	controlPad[1] |= 0x8000;
		
	if (Settings.MultiPlayer5Master)
	{
		controlPad[2] = controlPad[3] = controlPad[4] = 0;

		JoypadScanDirection(2, &(controlPad[2]));
		if (ISpKeyIsPressed(kISp3PR     ))	controlPad[2] |= 0x0010;
		if (ISpKeyIsPressed(kISp3PL     ))	controlPad[2] |= 0x0020;
		if (ISpKeyIsPressed(kISp3PX     ))	controlPad[2] |= 0x0040;
		if (ISpKeyIsPressed(kISp3PA     ))	controlPad[2] |= 0x0080;
		if (ISpKeyIsPressed(kISp3PStart ))	controlPad[2] |= 0x1000;
		if (ISpKeyIsPressed(kISp3PSelect))	controlPad[2] |= 0x2000;
		if (ISpKeyIsPressed(kISp3PY     ))	controlPad[2] |= 0x4000;
		if (ISpKeyIsPressed(kISp3PB     ))	controlPad[2] |= 0x8000; 
	
		JoypadScanDirection(3, &(controlPad[3]));
		if (ISpKeyIsPressed(kISp4PR     ))	controlPad[3] |= 0x0010;
		if (ISpKeyIsPressed(kISp4PL     ))	controlPad[3] |= 0x0020;
		if (ISpKeyIsPressed(kISp4PX     ))	controlPad[3] |= 0x0040;
		if (ISpKeyIsPressed(kISp4PA     ))	controlPad[3] |= 0x0080;
		if (ISpKeyIsPressed(kISp4PStart ))	controlPad[3] |= 0x1000;
		if (ISpKeyIsPressed(kISp4PSelect))	controlPad[3] |= 0x2000;
		if (ISpKeyIsPressed(kISp4PY     ))	controlPad[3] |= 0x4000;
		if (ISpKeyIsPressed(kISp4PB     ))	controlPad[3] |= 0x8000;

		JoypadScanDirection(4, &(controlPad[4]));
		if (ISpKeyIsPressed(kISp5PR     ))	controlPad[4] |= 0x0010;
		if (ISpKeyIsPressed(kISp5PL     ))	controlPad[4] |= 0x0020;
		if (ISpKeyIsPressed(kISp5PX     ))	controlPad[4] |= 0x0040;
		if (ISpKeyIsPressed(kISp5PA     ))	controlPad[4] |= 0x0080;
		if (ISpKeyIsPressed(kISp5PStart ))	controlPad[4] |= 0x1000;
		if (ISpKeyIsPressed(kISp5PSelect))	controlPad[4] |= 0x2000;
		if (ISpKeyIsPressed(kISp5PY     ))	controlPad[4] |= 0x4000;
		if (ISpKeyIsPressed(kISp5PB     ))	controlPad[4] |= 0x8000;
	}

	GetKeys(myKeys);

	if (KeyIsPressed(myKeys, keyCode[kKeyScreenshot]))
	{
		Settings.TakeScreenshot = true;
		while (KeyIsPressed(myKeys, keyCode[kKeyScreenshot]))
			GetKeys(myKeys);
	}
	
	if (KeyIsPressed(myKeys, keyCode[kKeySPC]))
	{
		spc_is_dumping = 1;
		while (KeyIsPressed(myKeys, keyCode[kKeySPC]))
			GetKeys(myKeys);
	}
	
	if (KeyIsPressed(myKeys, kmEscKey))
	{	
		if (s9xthreadrunning)
			PostQueueToSubEventLoop();
		else
			running = false;

		return;
	}
	
	if (KeyIsPressed(myKeys, keyCode[kKeyFreeze]))
	{
		SNES9X_Freeze();
		ClearGFXScreen();
		return;
	}
		
	if (KeyIsPressed(myKeys, keyCode[kKeyDefrost]))
	{
		SNES9X_Defrost();
		ClearGFXScreen();
		return;
	}
	
	for (index = 0; index < 5; index++)
	{    
		if (KeyIsPressed(myKeys, fkey[index]))
		{
			if (!heldFkey[index])
			{
				SNES9X_ToggleLayer(index); 
				heldFkey[index] = true;
			}			
		}
		else
			heldFkey[index] = false;
	}

	if (KeyIsPressed(myKeys, keyCode[k1PR]     ))	controlPad[0] |= 0x0010;
	if (KeyIsPressed(myKeys, keyCode[k1PL]     ))	controlPad[0] |= 0x0020;
	if (KeyIsPressed(myKeys, keyCode[k1PX]     ))	controlPad[0] |= 0x0040;
	if (KeyIsPressed(myKeys, keyCode[k1PA]     ))	controlPad[0] |= 0x0080;
	if (KeyIsPressed(myKeys, keyCode[k1PRight] ))	controlPad[0] |= 0x0100;
	if (KeyIsPressed(myKeys, keyCode[k1PLeft]  ))	controlPad[0] |= 0x0200;
	if (KeyIsPressed(myKeys, keyCode[k1PDown]  ))	controlPad[0] |= 0x0400;
	if (KeyIsPressed(myKeys, keyCode[k1PUp]    ))	controlPad[0] |= 0x0800;
	if (KeyIsPressed(myKeys, keyCode[k1PStart] ))	controlPad[0] |= 0x1000;
	if (KeyIsPressed(myKeys, keyCode[k1PSelect]))	controlPad[0] |= 0x2000;
	if (KeyIsPressed(myKeys, keyCode[k1PY]     ))	controlPad[0] |= 0x4000;
	if (KeyIsPressed(myKeys, keyCode[k1PB]     ))	controlPad[0] |= 0x8000;
	
	if (KeyIsPressed(myKeys, keyCode[k2PR]     ))	controlPad[1] |= 0x0010;
	if (KeyIsPressed(myKeys, keyCode[k2PL]     ))	controlPad[1] |= 0x0020;
	if (KeyIsPressed(myKeys, keyCode[k2PX]     ))	controlPad[1] |= 0x0040;
	if (KeyIsPressed(myKeys, keyCode[k2PA]     ))	controlPad[1] |= 0x0080;
	if (KeyIsPressed(myKeys, keyCode[k2PRight] ))	controlPad[1] |= 0x0100;
	if (KeyIsPressed(myKeys, keyCode[k2PLeft]  ))	controlPad[1] |= 0x0200;
	if (KeyIsPressed(myKeys, keyCode[k2PDown]  ))	controlPad[1] |= 0x0400;
	if (KeyIsPressed(myKeys, keyCode[k2PUp]    ))	controlPad[1] |= 0x0800;
	if (KeyIsPressed(myKeys, keyCode[k2PStart] ))	controlPad[1] |= 0x1000;
	if (KeyIsPressed(myKeys, keyCode[k2PSelect]))	controlPad[1] |= 0x2000;
	if (KeyIsPressed(myKeys, keyCode[k2PY]     ))	controlPad[1] |= 0x4000;
	if (KeyIsPressed(myKeys, keyCode[k2PB]     ))	controlPad[1] |= 0x8000;
	
	if (enabletoggle)
	{
		if (KeyIsPressed(myKeys, keyCode[kKeyFastForward]) || ISpKeyIsPressed(kISpFastForward))
			toggleff = 1;
		else
		if (toggleff)
		{
			toggleff = 0;
			gFastForward = !gFastForward;
		}
	}
	else
		gFastForward = (KeyIsPressed(myKeys, keyCode[kKeyFastForward]) || ISpKeyIsPressed(kISpFastForward)) ? true : false;
	
	if (autofire)
	{
		long long	currentTime;
			
		Microseconds((UnsignedWide *) &currentTime);
		
		for (int i = 0; i < 2; i++)
		{
			if (autofireRec[i].buttonMask)
			{
				if (KeyIsPressed(myKeys, keyCode[autofireRec[i].keyboard]) || ISpKeyIsPressed(autofireRec[i].joypad))
				{
					if (currentTime > autofireRec[i].nextTime)
					{
						controlPad[i] |=  autofireRec[i].buttonMask;
						autofireRec[i].nextTime = currentTime + (long long) ((1.0 / (float) autofireRec[i].frequency) * 1000000.0);
					}
					else
						controlPad[i] &= ~autofireRec[i].buttonMask;
				}
			}
		}
	}
}

void S9xSetPalette(void) 
{
	if (directDisplay)
	{
		uint16	R, G, B;
		uint16	Brightness = IPPU.MaxBrightness * 138;
		int		i;

		for (i = 0; i < 256; i++)
		{
			R = ((PPU.CGDATA[i] >>  0) & 0x1F) * Brightness;
			G = ((PPU.CGDATA[i] >>  5) & 0x1F) * Brightness;
			B = ((PPU.CGDATA[i] >> 10) & 0x1F) * Brightness;

			(**myColorTable).ctTable[i].value     = i; 
			(**myColorTable).ctTable[i].rgb.red   = R; 
			(**myColorTable).ctTable[i].rgb.green = G;
			(**myColorTable).ctTable[i].rgb.blue  = B;
		}
	}
}

void S9xPutImage(int width, int height, Boolean sixteenBit)
{
	if (cfIsWatching)
		CheatFinderDrawWatchAddr();
	
	if (Settings.DisplayFrameRate)
	{
		static int	drawnFrames[60] = { 1,1,1,1,1, 1,1,1,1,1, 1,1,1,1,1, 1,1,1,1,1, 1,1,1,1,1, 1,1,1,1,1,
										1,1,1,1,1, 1,1,1,1,1, 1,1,1,1,1, 1,1,1,1,1, 1,1,1,1,1, 1,1,1,1,1 };
		static int	tableIndex = 0;
		int			frameCalc = 0, count;
		
		drawnFrames[tableIndex] = Settings.SkipFrames;

		if (gFastForward)
			drawnFrames[tableIndex] = (drawnFrames[tableIndex] + (kFastForwardRate / 2)) / kFastForwardRate;

		tableIndex = (tableIndex + 1) % 60;

		for (count = 0; count < 60; count++)
			frameCalc += drawnFrames[count];

		IPPU.DisplayedRenderedFrameCount = (Memory.ROMFramesPerSecond * 60) / frameCalc;
	}

	switch (drawingMethod)
	{
		case kDrawingOpenGL:
			S9xPutImageOpenGL(width, height);
			break;
			
		case kDrawingDirect:
			S9xPutImageDirect(width, height);
			break;
			
		case kDrawingBlitGL:
			S9xPutImageBlitGL(width, height);
	}
}

void S9xPutImageOpenGL(int snes_width, int snes_height)
{
	int			th = (snes_height > 240) ? 512 : 256;
	int			vh = (snes_height > 240) ? snes_height : snes_height * 2;
	const float	fw = 1.0;
	float		fh = (float) snes_height / (float) th;

	//imageDepth  = 16;
	imageWidth  = snes_width;
	imageHeight = snes_height;
	
	if (fullscreen)
	{
		CGLSetCurrentContext(glContext);
		
		if (glstretch)
		{
			if (glproportional)
			{
				int	pw = (int) ((float) glScreenH / vh * 512.0);
				
				glViewport((glScreenW - pw) >> 1, 0, pw, glScreenH);
			}
			else
				glViewport(0, 0, glScreenW, glScreenH);
		}
		else
			glViewport((glScreenW - 512) >> 1, (glScreenH - vh) >> 1, 512, vh);
	}
	else
	{
		aglSetCurrentContext(agContext);
		glViewport(0, (480 - vh) >> 1, 512, vh);
	}
	
	if (snes_width <= 256)		// 256 * 224, 256 * 239
	{
		glBindTexture(GL_TEXTURE_2D, OpenGL.textures[kGL256256]);
		glTexSubImage2D(GL_TEXTURE_2D, 0, 0, 0, 256, 256, OpenGL.format, OpenGL.type, GFX.Screen);
	}
	else
	{
		if (snes_height <= 256)	// 512 * 224, 512 * 239
		{
			glBindTexture(GL_TEXTURE_2D, OpenGL.textures[kGL512256]);
			glTexSubImage2D(GL_TEXTURE_2D, 0, 0, 0, 512, 256, OpenGL.format, OpenGL.type, GFX.Screen);
		}
		else					// 512 * 448, 512 * 478
		{
			glBindTexture(GL_TEXTURE_2D, OpenGL.textures[kGL512512]);
			glTexSubImage2D(GL_TEXTURE_2D, 0, 0, 0, 512, 512, OpenGL.format, OpenGL.type, GFX.Screen);
		}
	}
	
	glBegin(GL_TRIANGLE_STRIP);

	glTexCoord2f(0.0, fh);
	glVertex2f(-1.0, -1.0);	
	glTexCoord2f(fw, fh);
	glVertex2f(1.0, -1.0);	
	glTexCoord2f(0.0, 0.0);
	glVertex2f(-1.0, 1.0);
	glTexCoord2f(fw, 0.0);
	glVertex2f(1.0, 1.0);
	
	glEnd();
	
	if (fullscreen)
		CGLFlushDrawable(glContext);
	else
		aglSwapBuffers(agContext);
}

void S9xPutImageDirect(int width, int height)
{
	Rect	srcRect = { 0, 0, height, width }, copyRect;
	Blitter	BlitFn  = nil;

	copyRect.top = copyRect.left = 0;
	
	if (width > 256)
	{
		copyRect.right = width;
		
		if (height > 240)
		{
			copyRect.bottom = height;
			BlitFn = BlitFn512x480;
			
			if (height <= 448)
			{
				copyRect.top     = 16;
				copyRect.bottom += 16;
			}
		}
		else
		{			
			copyRect.bottom = height * 2;
			BlitFn = BlitFn512x240;
			
			if (height <= 224)
			{
				copyRect.top     = 16;
				copyRect.bottom += 16;
			}
			else
			if (height == 239)
			{
				copyRect.top     = 1;
				copyRect.bottom += 1;
			}
		}
	}
	else
	{
		if (doubleSize)
		{
			copyRect.right =   width * 2;
			copyRect.bottom = height * 2;
			
			if (height <= 224)
			{
				copyRect.top     = 16;
				copyRect.bottom += 16;
			}
			else
			if (height == 239)
			{
				copyRect.top     = 1;
				copyRect.bottom += 1;
			}
		}
		else
		{
			copyRect.top    = 120;
			copyRect.left   = 128;
			copyRect.bottom = 120 + height;
			copyRect.right  = 128 + width;
			
			if (height <= 224)
			{
				copyRect.top    += 8;
				copyRect.bottom += 8;
			}				
		}

		BlitFn = BlitFn256x240;
	}

	if (multiprocessor)
	{
		MPWaitOnSemaphore(readySemaphore, kDurationForever);

		mpDataBuffer->blitFn      = BlitFn;
		mpDataBuffer->srcRect     = srcRect;
		mpDataBuffer->copyRect    = copyRect;
		mpDataBuffer->gfxBuffer   = GFX.Screen;
		mpDataBuffer->dstPtr      = gWinScreenPtr;
		mpDataBuffer->dstRowBytes = gMacRowBytes;
				
		if ((width <= 256) && ((imageWidth != width) || (imageHeight != height)))
		{
			if (eagleMode || saiMode)
				BlitClearExtendArea(GFX.Screen, &srcRect);
			else
				BlitUpdateEntireDelta();
		}
		
		MPNotifyQueue(taskQueue, (void *) kMPBlitFrame, 0, 0);
		
		GFX.Screen = ((GFX.Screen == gfxScreenA) ? gfxScreenB : gfxScreenA);
	}
	else
	{
		if ((width <= 256) && ((imageWidth != width) || (imageHeight != height)))
		{
			if (eagleMode || saiMode)
				BlitClearExtendArea(GFX.Screen, &srcRect);
			else
				BlitUpdateEntireDelta();
		}
	
		BlitFn(GFX.Screen, gWinScreenPtr, gMacRowBytes, &srcRect, &copyRect);		
	}
	
	//imageDepth  = 16;
	imageWidth  = width;
	imageHeight = height;
}

void S9xPutImageBlitGL(int snes_width, int snes_height)
{
	Rect	srcRect = { 0, 0, snes_height, snes_width }, copyRect;
	Blitter	blitFn  = nil;
	
	copyRect.top = copyRect.left = 0;
	
	if (snes_width <= 256)			// 256 * 224, 256 * 239
	{
		if ((imageWidth != snes_width) || (imageHeight != snes_height))
		{
			if (eagleMode || saiMode)
				BlitClearExtendArea(GFX.Screen, &srcRect);
			else
				BlitUpdateEntireDelta();
		}
		
		copyRect.right  = snes_width  * 2;
		copyRect.bottom = snes_height * 2;
		blitFn = (saiMode ? BlitPix2xSaI16 : (eagleMode ? BlitPixEagle16 : BlitPixScaledTV16));
	}
	else
	{
		if (snes_height <= 256)		// 512 * 224, 512 * 239
		{
			copyRect.right  = snes_width;
			copyRect.bottom = snes_height * 2;
			blitFn = (tvMode ? BlitPixHiResTV16 : BlitPixHiRes16);
		}
		else						// 512 * 448, 512 * 478
		{
			copyRect.right  = snes_width;
			copyRect.bottom = snes_height;
			blitFn = BlitPixSmall16;
		}
	}
	
	gSrcP = snes_width << 1;
		
	if (multiprocessor)
	{
		MPWaitOnSemaphore(readySemaphore, kDurationForever);

		mpDataBuffer->blitFn      = blitFn;
		mpDataBuffer->srcRect     = srcRect;
		mpDataBuffer->copyRect    = copyRect;
		mpDataBuffer->gfxBuffer   = GFX.Screen;
		mpDataBuffer->dstPtr      = blitGLBuffer;
		mpDataBuffer->dstRowBytes = 1024;
		
		MPNotifyQueue(taskQueue, (void *) kMPBlitFrame, 0, 0);

		GFX.Screen = ((GFX.Screen == gfxScreenA) ? gfxScreenB : gfxScreenA);
	}
	else
	{
		blitFn(GFX.Screen, blitGLBuffer, 1024, &srcRect, &copyRect);
		S9xPutImageBlitGL2(copyRect.bottom);
	}
				
	//imageDepth  = 16;
	imageWidth  = snes_width;
	imageHeight = snes_height;
}

void S9xPutImageBlitGL2(int blit_height)
{
	const float	fw = 1.0;
	float		fh = (float) blit_height / 512.0;
	
	if (fullscreen)
	{
		CGLSetCurrentContext(glContext);
		
		if (glstretch)
		{
			if (glproportional)
			{
				int	pw = (int) ((float) glScreenH / (float) blit_height * 512.0);
				
				glViewport((glScreenW - pw) >> 1, 0, pw, glScreenH);
			}
			else
				glViewport(0, 0, glScreenW, glScreenH);
		}
		else
			glViewport((glScreenW - 512) >> 1, (glScreenH - blit_height) >> 1, 512, blit_height);
	}
	else
	{
		aglSetCurrentContext(agContext);
		glViewport(0, (480 - blit_height) >> 1, 512, blit_height);
	}
	
	glBindTexture(GL_TEXTURE_2D, OpenGL.textures[kGLBlit]);
	glTexSubImage2D(GL_TEXTURE_2D, 0, 0, 0, 512, 512, OpenGL.format, OpenGL.type, blitGLBuffer);
	
	glBegin(GL_TRIANGLE_STRIP);

	glTexCoord2f(0.0, fh);
	glVertex2f(-1.0, -1.0);	
	glTexCoord2f(fw, fh);
	glVertex2f(1.0, -1.0);	
	glTexCoord2f(0.0, 0.0);
	glVertex2f(-1.0, 1.0);
	glTexCoord2f(fw, 0.0);
	glVertex2f(1.0, 1.0);
	
	glEnd();
	
	if (fullscreen)
		CGLFlushDrawable(glContext);
	else
		aglSwapBuffers(agContext);
}

bool8 S9xInitUpdate(void)
{
    GFX.RealPitch = GFX.Pitch = GFX.Pitch2 = 512 * 2;
		
	return true;
}

bool8 S9xDeinitUpdate(int width, int height, bool8 sixteenBit)
{
	if (directDisplay)
		S9xPutImage(width, height, sixteenBit);
	
	return true;
}

void S9xTextMode(void)
{
	return;
}

void S9xGraphicsMode(void)
{
	return;
}

void S9xMessage(int type, int number, const char *message)
{
	printf("%s\n", message);
	
	if ((type == S9X_INFO) && (number == S9X_ROM_INFO))
		if (strstr(message, "checksum ok") == nil)
			AppearanceAlert(kAlertCautionAlert, kBadRomWarning, kBadRomHint);
}

const char * S9xBasename(const char *in)
{
	#pragma unused (in)

	return "";
}

bool8 S9xOpenSnapshotFile(const char *fname, bool8 read_only, STREAM *file)
{
    if (read_only)
    {
		if (0 != (*file = OPEN_STREAM(fname, "rb")))
		    return true;
    }
    else
    {
		if (0 != (*file = OPEN_STREAM(fname, "wb")))
		    return true;
    }

    return false;
}

void S9xCloseSnapshotFile(STREAM file)
{
    CLOSE_STREAM(file);
}

uint32 S9xReadJoypad(int which)
{
	return (which < 5) ? (0x80000000 | controlPad[which]) : 0;
}

inline void GetGameScreenRect(void)
{
	int	ph;
	
	ph = (imageHeight > 240) ? imageHeight : imageHeight * 2;
	
	if ((drawingMethod == kDrawingOpenGL) || (drawingMethod == kDrawingBlitGL))
	{
		if (fullscreen)
		{
			if (glstretch)
			{
				if (glproportional)
				{
					scopeViewInfo.width      = (int) ((float) glScreenH / (float) ph * 512.0);
					scopeViewInfo.height     = glScreenH;
					scopeViewInfo.globalLeft = (glScreenW - scopeViewInfo.width) >> 1;
					scopeViewInfo.globalTop  = 0;
				}
				else
				{
					scopeViewInfo.width      = glScreenW;
					scopeViewInfo.height     = glScreenH;
					scopeViewInfo.globalLeft = 0;
					scopeViewInfo.globalTop  = 0;
				}
			}
			else
			{
				scopeViewInfo.width      = 512;
				scopeViewInfo.height     = ph;
				scopeViewInfo.globalLeft = (glScreenW - 512) >> 1;
				scopeViewInfo.globalTop  = (glScreenH - ph ) >> 1;
			}
		}
		else
		{
			GetWindowBounds(gWindow, kWindowContentRgn, &gWindowRect);
			
			scopeViewInfo.width      = 512;
			scopeViewInfo.height     = ph;
			scopeViewInfo.globalLeft = gWindowRect.left;
			scopeViewInfo.globalTop  = gWindowRect.top + ((480 - ph) >> 1);
		}
	}
	else
	{
		if (fullscreen)
		{
			if ((imageWidth <= 256) && !doubleSize)
			{
				scopeViewInfo.width      = 256;
				scopeViewInfo.height     = imageHeight;
				scopeViewInfo.globalLeft = (glScreenW - 256        ) >> 1;
				scopeViewInfo.globalTop  = (glScreenH - imageHeight) >> 1;
			}
			else
			{
				scopeViewInfo.width      = 512;
				scopeViewInfo.height     = ph;
				scopeViewInfo.globalLeft = (glScreenW - 512) >> 1;
				scopeViewInfo.globalTop  = (glScreenH - ph ) >> 1;
			}
		}
		else
		{
			GetWindowBounds(gWindow, kWindowContentRgn, &gWindowRect);
			
			if ((imageWidth <= 256) && !doubleSize)
			{
				scopeViewInfo.width      = 256;
				scopeViewInfo.height     = imageHeight;
				scopeViewInfo.globalLeft = gWindowRect.left + 128;
				scopeViewInfo.globalTop  = gWindowRect.top  + 120 + ((240 - imageHeight) >> 1);
			}
			else
			{
				scopeViewInfo.width      = 512;
				scopeViewInfo.height     = ph;
				scopeViewInfo.globalLeft = gWindowRect.left;
				scopeViewInfo.globalTop  = gWindowRect.top + ((480 - ph) >> 1);
			}
		}
	}
}

bool8 S9xReadSuperScopePosition(int &x, int &y, uint32 &buttons)
{
	KeyMap	keys;
	Point	pos;
	
	GetKeys(keys);
	GetGlobalMouse(&pos);
	GetGameScreenRect();

	x = (int) (((float) (pos.h - scopeViewInfo.globalLeft)) / ((float) scopeViewInfo.width ) * (float) imageWidth );
	y = (int) (((float) (pos.v - scopeViewInfo.globalTop )) / ((float) scopeViewInfo.height) * (float) imageHeight);

	//buttons = Button(); For all OS versions. One button only. 
	//buttons = GetCurrentButtonState(); OSX 10.2 or later. Supports multi-button mouse.
	if (systemVersion < 0x1020)
		buttons = Button();
	else
		buttons = ISpKeyIsPressed(kISpMouseL) ? 1 : 0;
	
	if (KeyIsPressed(keys, keyCode[kKeyScopeCursor]) || ISpKeyIsPressed(kISpScopeC))	buttons |= 2;	
	if (KeyIsPressed(keys, keyCode[kKeyScopePause] ) || ISpKeyIsPressed(kISpScopeP))	buttons |= 8;
	
	if (KeyIsPressed(keys, keyCode[kKeyScopeTurbo] ) || ISpKeyIsPressed(kISpScopeT))
		togglescopeturbo = 1;
	else
	if (togglescopeturbo)
	{
		togglescopeturbo = 0;
		gScopeTurbo = !gScopeTurbo;
	}

	buttons |= 4 * (gScopeTurbo ? 1 : 0);

	return true;
}

bool8 S9xReadMousePosition(int which1, int &x, int &y, uint32 &buttons)
{
	if (which1 == 0)
	{
		KeyMap	keys;
		Point	pos;
		
		GetKeys(keys);
		GetGlobalMouse(&pos);
		GetGameScreenRect();
		
		x = (int) (((float) (pos.h - scopeViewInfo.globalLeft)) / ((float) scopeViewInfo.width ) * (float) imageWidth );
		y = (int) (((float) (pos.v - scopeViewInfo.globalTop )) / ((float) scopeViewInfo.height) * (float) imageHeight);
					
		//buttons = Button(); For all OS versions. One button only. 
		//buttons = GetCurrentButtonState(); OSX 10.2 or later. Supports multi-button mouse.
		if (systemVersion < 0x1020)
			buttons = Button();
		else
			buttons = (ISpKeyIsPressed(kISpMouseL) ? 1 : 0) | (ISpKeyIsPressed(kISpMouseR) ? 2 : 0);
		if ((buttons == 1) && KeyIsPressed(keys, kmCtrKey))
			buttons = 2;

		return true;
	}
	
	return false;
}

void S9xAutoSaveSRAM(void)
{
    SNES9X_SaveSRAM();
}

void S9xDisplayMessage(char *string)
{
	#pragma unused (string)
	
	return;
}

void ChangeTypeAndCreator(const char *path, OSType type, OSType creator)
{
	OSErr	err;
	FSRef	ref;

	err = FSPathMakeRef(path, &ref, nil);
	if (!err)
	{
		FSCatalogInfo	catinfo;
		
		((FileInfo *) &catinfo.finderInfo)->finderFlags   = 0;
		((FileInfo *) &catinfo.finderInfo)->reservedField = 0;
		((FileInfo *) &catinfo.finderInfo)->location.v    = 0;
		((FileInfo *) &catinfo.finderInfo)->location.h    = 0;
		((FileInfo *) &catinfo.finderInfo)->fileCreator   = creator;
    	((FileInfo *) &catinfo.finderInfo)->fileType      = type;
		
		err = FSSetCatalogInfo(&ref, kFSCatInfoFinderInfo, &catinfo);
	}
}

static int S9xCompareSDD1IndexEntries(const void *p1, const void *p2)
{
    return (*(uint32 *) p1 - *(uint32 *) p2);
}

void S9xLoadSDD1Data(void)
{
	FILE	*fs;
	int		len;
	char	path[PATH_MAX + 1], index[PATH_MAX + 1], data[PATH_MAX + 1];

    Memory.FreeSDD1Data();

    strcpy(path, S9xGetPackDirectory());
	
    strcpy(index, path);
    strcat(index, "SDD1GFX.idx");
    strcpy(data,  path);
    strcat(data,  "SDD1GFX.dat");

	len = 0;
	
    fs = fopen(index, "rb");
    if (fs)
    {
        fseek(fs, 0, SEEK_END);
        len = ftell(fs);
        rewind(fs);
        Memory.SDD1Index = (uint8 *) malloc(len);
        fread(Memory.SDD1Index, 1, len, fs);
        fclose(fs);

        Memory.SDD1Entries = len / 12;
		
		fs = fopen(data, "rb");
        if (!fs)
        {
            free((char *) Memory.SDD1Index);
            Memory.SDD1Index = nil;
            Memory.SDD1Entries = 0;
			S9xMessage(0, 0, "Graphics Pack not found!");
        }
        else
        {
 			uint8			*ptr;
			unsigned int	i;
			
			fseek(fs, 0, SEEK_END);
            len = ftell(fs);
            rewind(fs);
            Memory.SDD1Data = (uint8 *) malloc(len);
            fread(Memory.SDD1Data, 1, len, fs);
            fclose(fs);
			
			ptr = Memory.SDD1Index;
			
          	for (i = 0; i < Memory.SDD1Entries; i++, ptr += 12)
		    {
				SWAP_DWORD((*(uint32 *) (ptr + 0)));
				SWAP_DWORD((*(uint32 *) (ptr + 4)));
				SWAP_DWORD((*(uint32 *) (ptr + 8)));
		    }

			qsort(Memory.SDD1Index, Memory.SDD1Entries, 12, S9xCompareSDD1IndexEntries);
        }
    }
	else
		S9xMessage(0, 0, "Graphics Pack not found!");
}

const char * S9xGetPackDirectory(void)
{
	OSStatus	err;
	FSRef		ref;
	Boolean		isFolder, wasAliased;
	int			n;
	char		drive[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], ext[_MAX_EXT];

	static char	path[PATH_MAX + 1];
	static char	dummy[] = "~/";
	
	pfold[0] = 0;	// unused

	gPackFolderPath[0] = 0;

	strcpy(path, S9xGetFilename(".pac"));	
	n = strlen(path);
	if (n < 4)
		return dummy;
		
	path[n - 4] = 0;
	err = FSPathMakeRef(path, &ref, nil);
	if (err == noErr)
	{
		err = FSResolveAliasFile(&ref, false, &isFolder, &wasAliased);
		if ((err == noErr) && isFolder)
		{
			err = FSRefMakePath(&ref, path, PATH_MAX);
			if (err == noErr)
			{
				strcat(path, "/");
				strcpy(gPackFolderPath, path);

				return path;
			}
			else
				return dummy;
		}
	}

	char	fold[16];
		
	if (strncmp(Memory.ROMName, "Star Ocean",            10) == 0)
		strcpy(fold, "SOCNSDD1");
	else
	if (strncmp(Memory.ROMName, "STREET FIGHTER ALPHA2", 21) == 0)
	{
		if (Memory.ROMRegion == 1)
			strcpy(fold, "SFA2SDD1");
		else
			strcpy(fold, "SFA2SDD1.E");
	}
	else
	if (strncmp(Memory.ROMName, "STREET FIGHTER ZERO2" , 20) == 0)
		strcpy(fold, "SFZ2SDD1");
	else
	if (strncmp(Memory.ROMName, "SUPER POWER LEAG 4   ", 21) == 0)
		strcpy(fold, "SPL4-SP7");
	else
	if (strncmp(Memory.ROMName, "MOMOTETSU HAPPY      ", 21) == 0)
		strcpy(fold, "SMHT-SP7");
	else
	if (strncmp(Memory.ROMName, "HU TENGAI MAKYO ZERO ", 21) == 0)
		strcpy(fold, "FEOEZSP7");
	else
	if (strncmp(Memory.ROMName, "JUMP TENGAIMAKYO ZERO", 21) == 0)
		strcpy(fold, "SJUMPSP7");
	else
		strcpy(fold, "MISCPACK");
	
	_splitpath(path, drive, dir, fname, ext);
	_makepath(path, drive, dir, fold, "");

	err = FSPathMakeRef(path, &ref, nil);
	if (err == noErr)
	{
		err = FSResolveAliasFile(&ref, false, &isFolder, &wasAliased);
		if ((err == noErr) && isFolder)
		{
			err = FSRefMakePath(&ref, path, PATH_MAX);
			if (err == noErr)
			{
				strcat(path, "/");
				strcpy(gPackFolderPath, path);

				return path;
			}
			else
				return dummy;
		}
	}
	
	return dummy;
}

const char * S9xGetSnapshotDirectory(void)
{
	//printf("Reading SPC7110 Graphics Pack\n");
	return gPackFolderPath;
}

bool JustifierOffscreen(void)
{
	KeyMap	keys;
	
	GetKeys(keys);
	
	return (KeyIsPressed(keys, keyCode[kKeyOffScreen]) || ISpKeyIsPressed(kISpOffScreen));
}

void JustifierButtons(uint32& justifiers)
{
	KeyMap	keys;
	
	GetKeys(keys);
	
	if (systemVersion < 0x1020)
	{
		if (IPPU.Controller == SNES_JUSTIFIER_2)	// 2P
		{
			if (Button())
			{
				if (!KeyIsPressed(keys, kmCtrKey))
					justifiers |= 0x00200;
				else
					justifiers |= 0x00800;
			}
		}
		else										// 1P
		{
			if (Button())
			{
				if (!KeyIsPressed(keys, kmCtrKey))
					justifiers |= 0x00100;
				else
					justifiers |= 0x00400;
			}
		}
	}
	else	// 10.2.x or later
	{
		if (IPPU.Controller == SNES_JUSTIFIER_2)	// 2P
		{
			if (ISpKeyIsPressed(kISpMouseL))
			{
				if (!KeyIsPressed(keys, kmCtrKey))
					justifiers |= 0x00200;
				else
					justifiers |= 0x00800;
			}
					
			if (ISpKeyIsPressed(kISpMouseR))
				justifiers |= 0x00800;
		}
		else										// 1P
		{
			if (ISpKeyIsPressed(kISpMouseL))
			{
				if (!KeyIsPressed(keys, kmCtrKey))
					justifiers |= 0x00100;
				else
					justifiers |= 0x00400;
			}
					
			if (ISpKeyIsPressed(kISpMouseR))
				justifiers |= 0x00400;
		}
	}
}

void SetInfoDlgColor(unsigned char r, unsigned char g, unsigned char b)
{
	#pragma unused (r, g, b)
	
	return;
}

bool8 S9xDoScreenshot(int width, int height)
{
	Settings.TakeScreenshot = false;
	QuickScreenshot(width, height);
	
	return true;
}

extern "C" char * osd_GetPackDir(void)
{
	return S9xGetPackDirectory();
}

extern "C" const char * S9xGetFilenameInc(const char *inExt)
{
	if (strlen(inExt) < 4)
		return nil;
	
	switch (*(long *) (inExt + strlen(inExt) - 4))
	{
		case '.spc':
			return S9xGetSPCFilename();
		
		case '.png':
			return S9xGetPNGFilename();
	}
	
	return nil;
}
