/*******************************************************************************
  Snes9x - Portable Super Nintendo Entertainment System (TM) emulator.
 
  (c) Copyright 1996 - 2003 Gary Henderson (gary.henderson@ntlworld.com) and
                            Jerremy Koot (jkoot@snes9x.com)

  (c) Copyright 2002 - 2003 Matthew Kendora and
                            Brad Jorsch (anomie@users.sourceforge.net)
 

                      
  C4 x86 assembler and some C emulation code
  (c) Copyright 2000 - 2003 zsKnight (zsknight@zsnes.com),
                            _Demo_ (_demo_@zsnes.com), and
                            Nach (n-a-c-h@users.sourceforge.net)
                                          
  C4 C++ code
  (c) Copyright 2003 Brad Jorsch

  DSP-1 emulator code
  (c) Copyright 1998 - 2003 Ivar (ivar@snes9x.com), _Demo_, Gary Henderson,
                            John Weidman (jweidman@slip.net),
                            neviksti (neviksti@hotmail.com), and
                            Kris Bleakley (stinkfish@bigpond.com)
 
  DSP-2 emulator code
  (c) Copyright 2003 Kris Bleakley, John Weidman, neviksti, Matthew Kendora, and
                     Lord Nightmare (lord_nightmare@users.sourceforge.net

  OBC1 emulator code
  (c) Copyright 2001 - 2003 zsKnight, pagefault (pagefault@zsnes.com)
  Ported from x86 assembler to C by sanmaiwashi

  SPC7110 and RTC C++ emulator code
  (c) Copyright 2002 Matthew Kendora with research by
                     zsKnight, John Weidman, and Dark Force

  S-RTC C emulator code
  (c) Copyright 2001 John Weidman
  
  Super FX x86 assembler emulator code 
  (c) Copyright 1998 - 2003 zsKnight, _Demo_, and pagefault 

  Super FX C emulator code 
  (c) Copyright 1997 - 1999 Ivar and Gary Henderson.



 
  Specific ports contains the works of other authors. See headers in
  individual files.
 
  Snes9x homepage: http://www.snes9x.com
 
  Permission to use, copy, modify and distribute Snes9x in both binary and
  source form, for non-commercial purposes, is hereby granted without fee,
  providing that this license information and copyright notice appear with
  all copies and any derived work.
 
  This software is provided 'as-is', without any express or implied
  warranty. In no event shall the authors be held liable for any damages
  arising from the use of this software.
 
  Snes9x is freeware for PERSONAL USE only. Commercial users should
  seek permission of the copyright holders first. Commercial use includes
  charging money for Snes9x or software derived from Snes9x.
 
  The copyright holders request that bug fixes and improvements to the code
  should be forwarded to them so everyone can benefit from the modifications
  in future versions.
 
  Super NES and Super Nintendo Entertainment System are trademarks of
  Nintendo Co., Limited and its subsidiary companies.
*******************************************************************************/

/*******************************************************************************
  Snes9x custom (Snes9x for Mac OS X) by zones
  
  This build was started from John Stiles' port.
*******************************************************************************/

void Initialize(void);
void Deinitialize(void);
void InitClut(void);
void DeinitClut(void);
void InitGraphics(void);
void DeinitGraphics(void);
void InitMacSound(void);
void DeinitMacSound(void);
void InitGameWindow(void);
void DeinitGameWindow(void);
void InitRecentItems(void);
void DeinitRecentItems(void);
void ClearRecentItems(void);
void AddRecentItem(FSRef *);
void InitRecentMenu(void);
void DeinitRecentMenu(void);
void BuildRecentMenu(void);
void PrepareMenus(void);
void EnableMenus(void);
void DisableMenus(void);
void LegacyEventLoop(void);
void PostQueueToSubEventLoop(void);
void ProcessInput(void);
void QuickScreenshot(int, int);
void GetScreenAsPICTHandle(int, int, int, int);
void WriteScreenAsPICTResource(FSSpec *, int, int);
void S9xDisplayMessage(char *);
void S9xPutImage(int, int, Boolean);
void S9xPutImageOpenGL(int, int);
void S9xPutImageDirect(int, int);
void S9xPutImageBlitGL(int, int);
void S9xPutImageBlitGL2(int);
void ClearGFXScreen(void);
void DrawPauseScreen(void);
void ChangeInputDevice(void);
void ChangeTypeAndCreator(const char *, OSType, OSType);
void _splitpath(const char *, char *, char *, char *, char *);
void _makepath(char *, const char *, const char *, const char *, const char *);
void * MacSNES9XThread(void *);
int PromptFreezeDefrost(Boolean);
const char * S9xGetPackDirectory(void);
const char * S9xGetFreezeFilename(int);
const char * S9xGetPNGFilename(void);
OSStatus HandleMenuChoice(long, Boolean *);
OSErr FindSNESFolder(FSRef *, char *, const char *);
OSErr FindApplicationSupportFolder(FSRef *, char *, const char *);
Boolean IsLockedMedia(FSVolumeRefNum);
pascal OSStatus SubEventHandler(EventHandlerCallRef, EventRef, void *);
pascal OSStatus MainEventHandler(EventHandlerCallRef, EventRef, void *);
pascal OSStatus GameWindowEventHandler(EventHandlerCallRef, EventRef, void *);

extern uint32			controlPad[5];
extern bool8			cartOpen, finished, doubleSize, autoRes, running,
						mouseActive, tvMode, smoothMode, eagleMode, saiMode,
						lockedROMMedia, fullscreen, saveInROMFolder, multiprocessor, vsync,
						startopendlog, showtimeinfrz, autofire, enabletoggle, allowevent,
						glstretch, glproportional, gl32bit, scopecursor, hidExist, applycheat;
extern uint8			romDetect, interleaveDetect;
extern int 				imageWidth, imageHeight, imageDepth;
extern int64 			lastFrame;
extern long				drawingMethod;
extern unsigned long	spcFileCount, pngFileCount;
extern WindowPtr		gWindow;
extern int				macBufferSize, macBufferCount, mac7110Load, musicboxmode;
extern int				padSetting, deviceSetting;
extern float			macSoundPitch, macSoundPitchMaster;
extern SInt32			macSoundVolume;

#define	kDrawingDirect	1
#define	kDrawingOpenGL	2
#define	kDrawingBlitGL	3

typedef struct
{
	long long	nextTime;
	int			keyboard;
	int			joypad;
	uint16		buttonMask;
	SInt32		frequency;
}	AutoFireState;

extern AutoFireState	autofireRec[5];
